import { defineComponent as xt, ref as Ie, onMounted as vo, onUnmounted as yo, computed as Tt, watch as Et, toRefs as go, openBlock as At, createElementBlock as Rt, createElementVNode as rt, normalizeStyle as wo, withDirectives as bo, vShow as Co, renderSlot as Dr, withModifiers as nt } from "vue";
var Mr = (r, i, a) => {
  if (!i.has(r))
    throw TypeError("Cannot " + a);
}, wr = (r, i, a) => (Mr(r, i, "read from private field"), a ? a.call(r) : i.get(r)), _o = (r, i, a) => {
  if (i.has(r))
    throw TypeError("Cannot add the same private member more than once");
  i instanceof WeakSet ? i.add(r) : i.set(r, a);
}, $o = (r, i, a, c) => (Mr(r, i, "write to private field"), c ? c.call(r, a) : i.set(r, a), a);
const br = [
  "aztec",
  "code_128",
  "code_39",
  "code_93",
  "codabar",
  "data_matrix",
  "ean_13",
  "ean_8",
  "itf",
  "pdf417",
  "qr_code",
  "upc_a",
  "upc_e",
  "unknown"
];
function So(r) {
  if (xr(r))
    return {
      width: r.naturalWidth,
      height: r.naturalHeight
    };
  if (Ar(r))
    return {
      width: r.width.baseVal.value,
      height: r.height.baseVal.value
    };
  if (Rr(r))
    return {
      width: r.videoWidth,
      height: r.videoHeight
    };
  if (Fr(r))
    return {
      width: r.width,
      height: r.height
    };
  if (jr(r))
    return {
      width: r.displayWidth,
      height: r.displayHeight
    };
  if (kr(r))
    return {
      width: r.width,
      height: r.height
    };
  if (Ir(r))
    return {
      width: r.width,
      height: r.height
    };
  throw new TypeError(
    "The provided value is not of type '(Blob or HTMLCanvasElement or HTMLImageElement or HTMLVideoElement or ImageBitmap or ImageData or OffscreenCanvas or SVGImageElement or VideoFrame)'."
  );
}
function xr(r) {
  try {
    return r instanceof HTMLImageElement;
  } catch (i) {
    return !1;
  }
}
function Ar(r) {
  try {
    return r instanceof SVGImageElement;
  } catch (i) {
    return !1;
  }
}
function Rr(r) {
  try {
    return r instanceof HTMLVideoElement;
  } catch (i) {
    return !1;
  }
}
function kr(r) {
  try {
    return r instanceof HTMLCanvasElement;
  } catch (i) {
    return !1;
  }
}
function Fr(r) {
  try {
    return r instanceof ImageBitmap;
  } catch (i) {
    return !1;
  }
}
function Ir(r) {
  try {
    return r instanceof OffscreenCanvas;
  } catch (i) {
    return !1;
  }
}
function jr(r) {
  try {
    return r instanceof VideoFrame;
  } catch (i) {
    return !1;
  }
}
function Ur(r) {
  try {
    return r instanceof Blob;
  } catch (i) {
    return !1;
  }
}
function Po(r) {
  try {
    return r instanceof ImageData;
  } catch (i) {
    return !1;
  }
}
function To(r, i) {
  try {
    const a = new OffscreenCanvas(r, i);
    if (a.getContext("2d") instanceof OffscreenCanvasRenderingContext2D)
      return a;
    throw void 0;
  } catch (a) {
    const c = document.createElement("canvas");
    return c.width = r, c.height = i, c;
  }
}
async function Hr(r) {
  if (xr(r) && !await Mo(r))
    throw new DOMException(
      "Failed to load or decode HTMLImageElement.",
      "InvalidStateError"
    );
  if (Ar(r) && !await xo(r))
    throw new DOMException(
      "Failed to load or decode SVGImageElement.",
      "InvalidStateError"
    );
  if (jr(r) && Ao(r))
    throw new DOMException("VideoFrame is closed.", "InvalidStateError");
  if (Rr(r) && (r.readyState === 0 || r.readyState === 1))
    throw new DOMException("Invalid element or state.", "InvalidStateError");
  if (Fr(r) && ko(r))
    throw new DOMException(
      "The image source is detached.",
      "InvalidStateError"
    );
  const { width: i, height: a } = So(r);
  if (i === 0 || a === 0)
    return null;
  const c = To(i, a).getContext("2d");
  c.drawImage(r, 0, 0);
  try {
    return c.getImageData(0, 0, i, a);
  } catch (f) {
    throw new DOMException("Source would taint origin.", "SecurityError");
  }
}
async function Eo(r) {
  let i;
  try {
    if (createImageBitmap)
      i = await createImageBitmap(r);
    else if (Image) {
      i = new Image();
      let a = "";
      try {
        a = URL.createObjectURL(r), i.src = a, await i.decode();
      } finally {
        URL.revokeObjectURL(a);
      }
    } else
      return r;
  } catch (a) {
    throw new DOMException(
      "Failed to load or decode Blob.",
      "InvalidStateError"
    );
  }
  return await Hr(i);
}
function Oo(r) {
  const { width: i, height: a } = r;
  if (i === 0 || a === 0)
    return null;
  const c = r.getContext("2d");
  try {
    return c.getImageData(0, 0, i, a);
  } catch (f) {
    throw new DOMException("Source would taint origin.", "SecurityError");
  }
}
async function Do(r) {
  if (Ur(r))
    return await Eo(r);
  if (Po(r)) {
    if (Ro(r))
      throw new DOMException(
        "The image data has been detached.",
        "InvalidStateError"
      );
    return r;
  }
  return kr(r) || Ir(r) ? Oo(r) : await Hr(r);
}
async function Mo(r) {
  try {
    return await r.decode(), !0;
  } catch (i) {
    return !1;
  }
}
async function xo(r) {
  var i;
  try {
    return await ((i = r.decode) == null ? void 0 : i.call(r)), !0;
  } catch (a) {
    return !1;
  }
}
function Ao(r) {
  return r.format === null;
}
function Ro(r) {
  return r.data.buffer.byteLength === 0;
}
function ko(r) {
  return r.width === 0 && r.height === 0;
}
function Cr(r, i) {
  return r instanceof DOMException ? new DOMException(`${i}: ${r.message}`, r.name) : r instanceof Error ? new r.constructor(`${i}: ${r.message}`) : new Error(`${i}: ${r}`);
}
const _r = (r) => {
  let i;
  const a = /* @__PURE__ */ new Set(), c = (m, w) => {
    const b = typeof m == "function" ? m(i) : m;
    if (!Object.is(b, i)) {
      const v = i;
      i = (w != null ? w : typeof b != "object") ? b : Object.assign({}, i, b), a.forEach((_) => _(i, v));
    }
  }, f = () => i, p = { setState: c, getState: f, subscribe: (m) => (a.add(m), () => a.delete(m)), destroy: () => {
    a.clear();
  } };
  return i = r(c, f, p), p;
}, Fo = (r) => r ? _r(r) : _r, Io = {
  locateFile: (r, i) => {
    var a;
    const c = (a = r.match(/_(.+?)\.wasm$/)) == null ? void 0 : a[1];
    return c ? `https://fastly.jsdelivr.net/npm/@sec-ant/zxing-wasm@2.1.5/dist/${c}/${r}` : i + r;
  }
}, ge = Fo()(() => ({
  zxingModuleWeakMap: /* @__PURE__ */ new WeakMap(),
  zxingModuleOverrides: Io
}));
function ki(r) {
  ge.setState({
    zxingModuleOverrides: r
  });
}
function kt(r, i = ge.getState().zxingModuleOverrides) {
  const { zxingModuleWeakMap: a } = ge.getState(), c = a.get(
    r
  );
  if (c && Object.is(i, ge.getState().zxingModuleOverrides))
    return c;
  {
    ge.setState({
      zxingModuleOverrides: i
    });
    const f = r(i);
    return a.set(r, f), f;
  }
}
const $r = [
  "Aztec",
  "Codabar",
  "Code128",
  "Code39",
  "Code93",
  "DataBar",
  "DataBarExpanded",
  "DataMatrix",
  "EAN-13",
  "EAN-8",
  "ITF",
  "Linear-Codes",
  "Matrix-Codes",
  "MaxiCode",
  "MicroQRCode",
  "None",
  "PDF417",
  "QRCode",
  "UPC-A",
  "UPC-E"
], Z = {
  tryHarder: !0,
  formats: [],
  maxSymbols: 255
};
async function jo(r, {
  tryHarder: i = Z.tryHarder,
  formats: a = Z.formats,
  maxSymbols: c = Z.maxSymbols
} = Z, f) {
  const p = await kt(
    f,
    ge.getState().zxingModuleOverrides
  ), { size: m } = r, w = new Uint8Array(await r.arrayBuffer()), b = p._malloc(m);
  p.HEAP8.set(w, b);
  const v = p.readBarcodesFromImage(
    b,
    m,
    i,
    Lr(a),
    c
  );
  p._free(b);
  const _ = [];
  for (let S = 0; S < v.size(); ++S) {
    const $ = v.get(S);
    _.push({
      ...$,
      format: Wr($.format)
    });
  }
  return _;
}
async function Uo(r, {
  tryHarder: i = Z.tryHarder,
  formats: a = Z.formats,
  maxSymbols: c = Z.maxSymbols
} = Z, f) {
  const p = await kt(
    f,
    ge.getState().zxingModuleOverrides
  ), {
    data: m,
    width: w,
    height: b,
    data: { byteLength: v }
  } = r, _ = p._malloc(v);
  p.HEAP8.set(m, _);
  const S = p.readBarcodesFromPixmap(
    _,
    w,
    b,
    i,
    Lr(a),
    c
  );
  p._free(_);
  const $ = [];
  for (let H = 0; H < S.size(); ++H) {
    const j = S.get(H);
    $.push({
      ...j,
      format: Wr(j.format)
    });
  }
  return $;
}
function Lr(r) {
  return r.join("|");
}
function Wr(r) {
  const i = Sr(r);
  let a = 0, c = $r.length - 1;
  for (; a <= c; ) {
    const f = Math.floor((a + c) / 2), p = $r[f], m = Sr(p);
    if (m === i)
      return p;
    m < i ? a = f + 1 : c = f - 1;
  }
  return "None";
}
function Sr(r) {
  return r.toLowerCase().replace(/_-\[\]/g, "");
}
var Ft = (() => {
  var r = import.meta.url;
  return function(i = {}) {
    var a = i, c, f;
    a.ready = new Promise((e, t) => {
      c = e, f = t;
    });
    var p = Object.assign({}, a), m = "./this.program", w = typeof window == "object", b = typeof importScripts == "function";
    typeof process == "object" && typeof process.versions == "object" && process.versions.node;
    var v = "";
    function _(e) {
      return a.locateFile ? a.locateFile(e, v) : v + e;
    }
    var S;
    (w || b) && (b ? v = self.location.href : typeof document < "u" && document.currentScript && (v = document.currentScript.src), r && (v = r), v.indexOf("blob:") !== 0 ? v = v.substr(0, v.replace(/[?#].*/, "").lastIndexOf("/") + 1) : v = "", b && (S = (e) => {
      var t = new XMLHttpRequest();
      return t.open("GET", e, !1), t.responseType = "arraybuffer", t.send(null), new Uint8Array(t.response);
    })), a.print || console.log.bind(console);
    var $ = a.printErr || console.error.bind(console);
    Object.assign(a, p), p = null, a.arguments && a.arguments, a.thisProgram && (m = a.thisProgram), a.quit && a.quit;
    var H;
    a.wasmBinary && (H = a.wasmBinary), a.noExitRuntime, typeof WebAssembly != "object" && Ce("no native wasm support detected");
    var j, L = !1, U, E, F, q, B, I, we, be;
    function Te() {
      var e = j.buffer;
      a.HEAP8 = U = new Int8Array(e), a.HEAP16 = F = new Int16Array(e), a.HEAPU8 = E = new Uint8Array(e), a.HEAPU16 = q = new Uint16Array(e), a.HEAP32 = B = new Int32Array(e), a.HEAPU32 = I = new Uint32Array(e), a.HEAPF32 = we = new Float32Array(e), a.HEAPF64 = be = new Float64Array(e);
    }
    var Ee = [], Oe = [], Ue = [];
    function st() {
      if (a.preRun)
        for (typeof a.preRun == "function" && (a.preRun = [a.preRun]); a.preRun.length; )
          De(a.preRun.shift());
      ht(Ee);
    }
    function ct() {
      ht(Oe);
    }
    function ut() {
      if (a.postRun)
        for (typeof a.postRun == "function" && (a.postRun = [a.postRun]); a.postRun.length; )
          lt(a.postRun.shift());
      ht(Ue);
    }
    function De(e) {
      Ee.unshift(e);
    }
    function He(e) {
      Oe.unshift(e);
    }
    function lt(e) {
      Ue.unshift(e);
    }
    var ae = 0, X = null;
    function re(e) {
      ae++, a.monitorRunDependencies && a.monitorRunDependencies(ae);
    }
    function dt(e) {
      if (ae--, a.monitorRunDependencies && a.monitorRunDependencies(ae), ae == 0 && X) {
        var t = X;
        X = null, t();
      }
    }
    function Ce(e) {
      a.onAbort && a.onAbort(e), e = "Aborted(" + e + ")", $(e), L = !0, e += ". Build with -sASSERTIONS for more info.";
      var t = new WebAssembly.RuntimeError(e);
      throw f(t), t;
    }
    var ft = "data:application/octet-stream;base64,";
    function Le(e) {
      return e.startsWith(ft);
    }
    var oe;
    a.locateFile ? (oe = "zxing_reader.wasm", Le(oe) || (oe = _(oe))) : oe = new URL("/reader/zxing_reader.wasm", self.location).href;
    function We(e) {
      if (e == oe && H)
        return new Uint8Array(H);
      if (S)
        return S(e);
      throw "both async and sync fetching of the wasm failed";
    }
    function tn(e) {
      return !H && (w || b) && typeof fetch == "function" ? fetch(e, { credentials: "same-origin" }).then((t) => {
        if (!t.ok)
          throw "failed to load wasm binary file at '" + e + "'";
        return t.arrayBuffer();
      }).catch(() => We(e)) : Promise.resolve().then(() => We(e));
    }
    function jt(e, t, n) {
      return tn(e).then((o) => WebAssembly.instantiate(o, t)).then((o) => o).then(n, (o) => {
        $(`failed to asynchronously prepare wasm: ${o}`), Ce(o);
      });
    }
    function rn(e, t, n, o) {
      return !e && typeof WebAssembly.instantiateStreaming == "function" && !Le(t) && typeof fetch == "function" ? fetch(t, { credentials: "same-origin" }).then((s) => {
        var u = WebAssembly.instantiateStreaming(s, n);
        return u.then(o, function(l) {
          return $(`wasm streaming compile failed: ${l}`), $("falling back to ArrayBuffer instantiation"), jt(t, n, o);
        });
      }) : jt(t, n, o);
    }
    function nn() {
      var e = { a: Ia };
      function t(o, s) {
        return z = o.exports, j = z.qa, Te(), Zt = z.ua, He(z.ra), dt(), z;
      }
      re();
      function n(o) {
        t(o.instance);
      }
      if (a.instantiateWasm)
        try {
          return a.instantiateWasm(e, t);
        } catch (o) {
          $(`Module.instantiateWasm callback failed with error: ${o}`), f(o);
        }
      return rn(H, oe, e, n).catch(f), {};
    }
    var ht = (e) => {
      for (; e.length > 0; )
        e.shift()(a);
    }, Ve = [], ze = 0, an = (e) => {
      var t = new Be(e);
      return t.get_caught() || (t.set_caught(!0), ze--), t.set_rethrown(!1), Ve.push(t), hr(t.excPtr), t.get_exception_ptr();
    }, ie = 0, on = () => {
      D(0, 0);
      var e = Ve.pop();
      fr(e.excPtr), ie = 0;
    };
    function Be(e) {
      this.excPtr = e, this.ptr = e - 24, this.set_type = function(t) {
        I[this.ptr + 4 >> 2] = t;
      }, this.get_type = function() {
        return I[this.ptr + 4 >> 2];
      }, this.set_destructor = function(t) {
        I[this.ptr + 8 >> 2] = t;
      }, this.get_destructor = function() {
        return I[this.ptr + 8 >> 2];
      }, this.set_caught = function(t) {
        t = t ? 1 : 0, U[this.ptr + 12 >> 0] = t;
      }, this.get_caught = function() {
        return U[this.ptr + 12 >> 0] != 0;
      }, this.set_rethrown = function(t) {
        t = t ? 1 : 0, U[this.ptr + 13 >> 0] = t;
      }, this.get_rethrown = function() {
        return U[this.ptr + 13 >> 0] != 0;
      }, this.init = function(t, n) {
        this.set_adjusted_ptr(0), this.set_type(t), this.set_destructor(n);
      }, this.set_adjusted_ptr = function(t) {
        I[this.ptr + 16 >> 2] = t;
      }, this.get_adjusted_ptr = function() {
        return I[this.ptr + 16 >> 2];
      }, this.get_exception_ptr = function() {
        var t = mr(this.get_type());
        if (t)
          return I[this.excPtr >> 2];
        var n = this.get_adjusted_ptr();
        return n !== 0 ? n : this.excPtr;
      };
    }
    var sn = (e) => {
      throw ie || (ie = e), ie;
    }, pt = (e) => {
      var t = ie;
      if (!t)
        return Fe(0), 0;
      var n = new Be(t);
      n.set_adjusted_ptr(t);
      var o = n.get_type();
      if (!o)
        return Fe(0), t;
      for (var s in e) {
        var u = e[s];
        if (u === 0 || u === o)
          break;
        var l = n.ptr + 16;
        if (pr(u, o, l))
          return Fe(u), t;
      }
      return Fe(o), t;
    }, cn = () => pt([]), un = (e) => pt([e]), ln = (e, t) => pt([e, t]), dn = (e) => {
      var t = new Be(e).get_exception_ptr();
      return t;
    }, fn = () => {
      var e = Ve.pop();
      e || Ce("no exception to throw");
      var t = e.excPtr;
      throw e.get_rethrown() || (Ve.push(e), e.set_rethrown(!0), e.set_caught(!1), ze++), ie = t, ie;
    }, hn = (e, t, n) => {
      var o = new Be(e);
      throw o.init(t, n), ie = e, ze++, ie;
    }, pn = () => ze, Ge = {}, Ut = (e) => {
      for (; e.length; ) {
        var t = e.pop(), n = e.pop();
        n(t);
      }
    };
    function mt(e) {
      return this.fromWireType(B[e >> 2]);
    }
    var _e = {}, me = {}, qe = {}, Ht, Ne = (e) => {
      throw new Ht(e);
    }, ve = (e, t, n) => {
      e.forEach(function(d) {
        qe[d] = t;
      });
      function o(d) {
        var h = n(d);
        h.length !== e.length && Ne("Mismatched type converter count");
        for (var y = 0; y < e.length; ++y)
          se(e[y], h[y]);
      }
      var s = new Array(t.length), u = [], l = 0;
      t.forEach((d, h) => {
        me.hasOwnProperty(d) ? s[h] = me[d] : (u.push(d), _e.hasOwnProperty(d) || (_e[d] = []), _e[d].push(() => {
          s[h] = me[d], ++l, l === u.length && o(s);
        }));
      }), u.length === 0 && o(s);
    }, mn = (e) => {
      var t = Ge[e];
      delete Ge[e];
      var n = t.rawConstructor, o = t.rawDestructor, s = t.fields, u = s.map((l) => l.getterReturnType).concat(s.map((l) => l.setterArgumentType));
      ve([e], u, (l) => {
        var d = {};
        return s.forEach((h, y) => {
          var C = h.fieldName, T = l[y], O = h.getter, A = h.getterContext, W = l[y + s.length], Y = h.setter, V = h.setterContext;
          d[C] = { read: (J) => T.fromWireType(O(A, J)), write: (J, g) => {
            var P = [];
            Y(V, J, W.toWireType(P, g)), Ut(P);
          } };
        }), [{ name: t.name, fromWireType: (h) => {
          var y = {};
          for (var C in d)
            y[C] = d[C].read(h);
          return o(h), y;
        }, toWireType: (h, y) => {
          for (var C in d)
            if (!(C in y))
              throw new TypeError(`Missing field: "${C}"`);
          var T = n();
          for (C in d)
            d[C].write(T, y[C]);
          return h !== null && h.push(o, T), T;
        }, argPackAdvance: ce, readValueFromPointer: mt, destructorFunction: o }];
      });
    }, vn = (e, t, n, o, s) => {
    }, yn = () => {
      for (var e = new Array(256), t = 0; t < 256; ++t)
        e[t] = String.fromCharCode(t);
      Lt = e;
    }, Lt, Q = (e) => {
      for (var t = "", n = e; E[n]; )
        t += Lt[E[n++]];
      return t;
    }, $e, R = (e) => {
      throw new $e(e);
    };
    function gn(e, t, n = {}) {
      var o = t.name;
      if (e || R(`type "${o}" must have a positive integer typeid pointer`), me.hasOwnProperty(e)) {
        if (n.ignoreDuplicateRegistrations)
          return;
        R(`Cannot register type '${o}' twice`);
      }
      if (me[e] = t, delete qe[e], _e.hasOwnProperty(e)) {
        var s = _e[e];
        delete _e[e], s.forEach((u) => u());
      }
    }
    function se(e, t, n = {}) {
      if (!("argPackAdvance" in t))
        throw new TypeError("registerType registeredInstance requires argPackAdvance");
      return gn(e, t, n);
    }
    var ce = 8, wn = (e, t, n, o) => {
      t = Q(t), se(e, { name: t, fromWireType: function(s) {
        return !!s;
      }, toWireType: function(s, u) {
        return u ? n : o;
      }, argPackAdvance: ce, readValueFromPointer: function(s) {
        return this.fromWireType(E[s]);
      }, destructorFunction: null });
    }, bn = (e) => ({ count: e.count, deleteScheduled: e.deleteScheduled, preservePointerOnDelete: e.preservePointerOnDelete, ptr: e.ptr, ptrType: e.ptrType, smartPtr: e.smartPtr, smartPtrType: e.smartPtrType }), vt = (e) => {
      function t(n) {
        return n.$$.ptrType.registeredClass.name;
      }
      R(t(e) + " instance already deleted");
    }, yt = !1, Wt = (e) => {
    }, Cn = (e) => {
      e.smartPtr ? e.smartPtrType.rawDestructor(e.smartPtr) : e.ptrType.registeredClass.rawDestructor(e.ptr);
    }, Vt = (e) => {
      e.count.value -= 1;
      var t = e.count.value === 0;
      t && Cn(e);
    }, zt = (e, t, n) => {
      if (t === n)
        return e;
      if (n.baseClass === void 0)
        return null;
      var o = zt(e, t, n.baseClass);
      return o === null ? null : n.downcast(o);
    }, Bt = {}, _n = () => Object.keys(Ae).length, $n = () => {
      var e = [];
      for (var t in Ae)
        Ae.hasOwnProperty(t) && e.push(Ae[t]);
      return e;
    }, Me = [], gt = () => {
      for (; Me.length; ) {
        var e = Me.pop();
        e.$$.deleteScheduled = !1, e.delete();
      }
    }, xe, Sn = (e) => {
      xe = e, Me.length && xe && xe(gt);
    }, Pn = () => {
      a.getInheritedInstanceCount = _n, a.getLiveInheritedInstances = $n, a.flushPendingDeletes = gt, a.setDelayFunction = Sn;
    }, Ae = {}, Tn = (e, t) => {
      for (t === void 0 && R("ptr should not be undefined"); e.baseClass; )
        t = e.upcast(t), e = e.baseClass;
      return t;
    }, En = (e, t) => (t = Tn(e, t), Ae[t]), Ye = (e, t) => {
      (!t.ptrType || !t.ptr) && Ne("makeClassHandle requires ptr and ptrType");
      var n = !!t.smartPtrType, o = !!t.smartPtr;
      return n !== o && Ne("Both smartPtrType and smartPtr must be specified"), t.count = { value: 1 }, Re(Object.create(e, { $$: { value: t } }));
    };
    function On(e) {
      var t = this.getPointee(e);
      if (!t)
        return this.destructor(e), null;
      var n = En(this.registeredClass, t);
      if (n !== void 0) {
        if (n.$$.count.value === 0)
          return n.$$.ptr = t, n.$$.smartPtr = e, n.clone();
        var o = n.clone();
        return this.destructor(e), o;
      }
      function s() {
        return this.isSmartPointer ? Ye(this.registeredClass.instancePrototype, { ptrType: this.pointeeType, ptr: t, smartPtrType: this, smartPtr: e }) : Ye(this.registeredClass.instancePrototype, { ptrType: this, ptr: e });
      }
      var u = this.registeredClass.getActualType(t), l = Bt[u];
      if (!l)
        return s.call(this);
      var d;
      this.isConst ? d = l.constPointerType : d = l.pointerType;
      var h = zt(t, this.registeredClass, d.registeredClass);
      return h === null ? s.call(this) : this.isSmartPointer ? Ye(d.registeredClass.instancePrototype, { ptrType: d, ptr: h, smartPtrType: this, smartPtr: e }) : Ye(d.registeredClass.instancePrototype, { ptrType: d, ptr: h });
    }
    var Re = (e) => typeof FinalizationRegistry > "u" ? (Re = (t) => t, e) : (yt = new FinalizationRegistry((t) => {
      Vt(t.$$);
    }), Re = (t) => {
      var n = t.$$, o = !!n.smartPtr;
      if (o) {
        var s = { $$: n };
        yt.register(t, s, t);
      }
      return t;
    }, Wt = (t) => yt.unregister(t), Re(e)), Dn = () => {
      Object.assign(Je.prototype, { isAliasOf(e) {
        if (!(this instanceof Je) || !(e instanceof Je))
          return !1;
        var t = this.$$.ptrType.registeredClass, n = this.$$.ptr;
        e.$$ = e.$$;
        for (var o = e.$$.ptrType.registeredClass, s = e.$$.ptr; t.baseClass; )
          n = t.upcast(n), t = t.baseClass;
        for (; o.baseClass; )
          s = o.upcast(s), o = o.baseClass;
        return t === o && n === s;
      }, clone() {
        if (this.$$.ptr || vt(this), this.$$.preservePointerOnDelete)
          return this.$$.count.value += 1, this;
        var e = Re(Object.create(Object.getPrototypeOf(this), { $$: { value: bn(this.$$) } }));
        return e.$$.count.value += 1, e.$$.deleteScheduled = !1, e;
      }, delete() {
        this.$$.ptr || vt(this), this.$$.deleteScheduled && !this.$$.preservePointerOnDelete && R("Object already scheduled for deletion"), Wt(this), Vt(this.$$), this.$$.preservePointerOnDelete || (this.$$.smartPtr = void 0, this.$$.ptr = void 0);
      }, isDeleted() {
        return !this.$$.ptr;
      }, deleteLater() {
        return this.$$.ptr || vt(this), this.$$.deleteScheduled && !this.$$.preservePointerOnDelete && R("Object already scheduled for deletion"), Me.push(this), Me.length === 1 && xe && xe(gt), this.$$.deleteScheduled = !0, this;
      } });
    };
    function Je() {
    }
    var Mn = 48, xn = 57, Gt = (e) => {
      if (e === void 0)
        return "_unknown";
      e = e.replace(/[^a-zA-Z0-9_]/g, "$");
      var t = e.charCodeAt(0);
      return t >= Mn && t <= xn ? `_${e}` : e;
    };
    function qt(e, t) {
      return e = Gt(e), { [e]: function() {
        return t.apply(this, arguments);
      } }[e];
    }
    var Nt = (e, t, n) => {
      if (e[t].overloadTable === void 0) {
        var o = e[t];
        e[t] = function() {
          return e[t].overloadTable.hasOwnProperty(arguments.length) || R(`Function '${n}' called with an invalid number of arguments (${arguments.length}) - expects one of (${e[t].overloadTable})!`), e[t].overloadTable[arguments.length].apply(this, arguments);
        }, e[t].overloadTable = [], e[t].overloadTable[o.argCount] = o;
      }
    }, Yt = (e, t, n) => {
      a.hasOwnProperty(e) ? ((n === void 0 || a[e].overloadTable !== void 0 && a[e].overloadTable[n] !== void 0) && R(`Cannot register public name '${e}' twice`), Nt(a, e, e), a.hasOwnProperty(n) && R(`Cannot register multiple overloads of a function with the same number of arguments (${n})!`), a[e].overloadTable[n] = t) : (a[e] = t, n !== void 0 && (a[e].numArguments = n));
    };
    function An(e, t, n, o, s, u, l, d) {
      this.name = e, this.constructor = t, this.instancePrototype = n, this.rawDestructor = o, this.baseClass = s, this.getActualType = u, this.upcast = l, this.downcast = d, this.pureVirtualFunctions = [];
    }
    var wt = (e, t, n) => {
      for (; t !== n; )
        t.upcast || R(`Expected null or instance of ${n.name}, got an instance of ${t.name}`), e = t.upcast(e), t = t.baseClass;
      return e;
    };
    function Rn(e, t) {
      if (t === null)
        return this.isReference && R(`null is not a valid ${this.name}`), 0;
      t.$$ || R(`Cannot pass "${_t(t)}" as a ${this.name}`), t.$$.ptr || R(`Cannot pass deleted object as a pointer of type ${this.name}`);
      var n = t.$$.ptrType.registeredClass, o = wt(t.$$.ptr, n, this.registeredClass);
      return o;
    }
    function kn(e, t) {
      var n;
      if (t === null)
        return this.isReference && R(`null is not a valid ${this.name}`), this.isSmartPointer ? (n = this.rawConstructor(), e !== null && e.push(this.rawDestructor, n), n) : 0;
      t.$$ || R(`Cannot pass "${_t(t)}" as a ${this.name}`), t.$$.ptr || R(`Cannot pass deleted object as a pointer of type ${this.name}`), !this.isConst && t.$$.ptrType.isConst && R(`Cannot convert argument of type ${t.$$.smartPtrType ? t.$$.smartPtrType.name : t.$$.ptrType.name} to parameter type ${this.name}`);
      var o = t.$$.ptrType.registeredClass;
      if (n = wt(t.$$.ptr, o, this.registeredClass), this.isSmartPointer)
        switch (t.$$.smartPtr === void 0 && R("Passing raw pointer to smart pointer is illegal"), this.sharingPolicy) {
          case 0:
            t.$$.smartPtrType === this ? n = t.$$.smartPtr : R(`Cannot convert argument of type ${t.$$.smartPtrType ? t.$$.smartPtrType.name : t.$$.ptrType.name} to parameter type ${this.name}`);
            break;
          case 1:
            n = t.$$.smartPtr;
            break;
          case 2:
            if (t.$$.smartPtrType === this)
              n = t.$$.smartPtr;
            else {
              var s = t.clone();
              n = this.rawShare(n, de.toHandle(() => s.delete())), e !== null && e.push(this.rawDestructor, n);
            }
            break;
          default:
            R("Unsupporting sharing policy");
        }
      return n;
    }
    function Fn(e, t) {
      if (t === null)
        return this.isReference && R(`null is not a valid ${this.name}`), 0;
      t.$$ || R(`Cannot pass "${_t(t)}" as a ${this.name}`), t.$$.ptr || R(`Cannot pass deleted object as a pointer of type ${this.name}`), t.$$.ptrType.isConst && R(`Cannot convert argument of type ${t.$$.ptrType.name} to parameter type ${this.name}`);
      var n = t.$$.ptrType.registeredClass, o = wt(t.$$.ptr, n, this.registeredClass);
      return o;
    }
    function Jt(e) {
      return this.fromWireType(I[e >> 2]);
    }
    var In = () => {
      Object.assign(Qe.prototype, { getPointee(e) {
        return this.rawGetPointee && (e = this.rawGetPointee(e)), e;
      }, destructor(e) {
        this.rawDestructor && this.rawDestructor(e);
      }, argPackAdvance: ce, readValueFromPointer: Jt, deleteObject(e) {
        e !== null && e.delete();
      }, fromWireType: On });
    };
    function Qe(e, t, n, o, s, u, l, d, h, y, C) {
      this.name = e, this.registeredClass = t, this.isReference = n, this.isConst = o, this.isSmartPointer = s, this.pointeeType = u, this.sharingPolicy = l, this.rawGetPointee = d, this.rawConstructor = h, this.rawShare = y, this.rawDestructor = C, !s && t.baseClass === void 0 ? o ? (this.toWireType = Rn, this.destructorFunction = null) : (this.toWireType = Fn, this.destructorFunction = null) : this.toWireType = kn;
    }
    var Qt = (e, t, n) => {
      a.hasOwnProperty(e) || Ne("Replacing nonexistant public symbol"), a[e].overloadTable !== void 0 && n !== void 0 ? a[e].overloadTable[n] = t : (a[e] = t, a[e].argCount = n);
    }, jn = (e, t, n) => {
      var o = a["dynCall_" + e];
      return n && n.length ? o.apply(null, [t].concat(n)) : o.call(null, t);
    }, Ze = [], Zt, k = (e) => {
      var t = Ze[e];
      return t || (e >= Ze.length && (Ze.length = e + 1), Ze[e] = t = Zt.get(e)), t;
    }, Un = (e, t, n) => {
      if (e.includes("j"))
        return jn(e, t, n);
      var o = k(t).apply(null, n);
      return o;
    }, Hn = (e, t) => {
      var n = [];
      return function() {
        return n.length = 0, Object.assign(n, arguments), Un(e, t, n);
      };
    }, te = (e, t) => {
      e = Q(e);
      function n() {
        return e.includes("j") ? Hn(e, t) : k(t);
      }
      var o = n();
      return typeof o != "function" && R(`unknown function pointer with signature ${e}: ${t}`), o;
    }, Ln = (e, t) => {
      var n = qt(t, function(o) {
        this.name = t, this.message = o;
        var s = new Error(o).stack;
        s !== void 0 && (this.stack = this.toString() + `
` + s.replace(/^Error(:[^\n]*)?\n/, ""));
      });
      return n.prototype = Object.create(e.prototype), n.prototype.constructor = n, n.prototype.toString = function() {
        return this.message === void 0 ? this.name : `${this.name}: ${this.message}`;
      }, n;
    }, Kt, Xt = (e) => {
      var t = dr(e), n = Q(t);
      return ue(t), n;
    }, Ke = (e, t) => {
      var n = [], o = {};
      function s(u) {
        if (!o[u] && !me[u]) {
          if (qe[u]) {
            qe[u].forEach(s);
            return;
          }
          n.push(u), o[u] = !0;
        }
      }
      throw t.forEach(s), new Kt(`${e}: ` + n.map(Xt).join([", "]));
    }, Wn = (e, t, n, o, s, u, l, d, h, y, C, T, O) => {
      C = Q(C), u = te(s, u), d && (d = te(l, d)), y && (y = te(h, y)), O = te(T, O);
      var A = Gt(C);
      Yt(A, function() {
        Ke(`Cannot construct ${C} due to unbound types`, [o]);
      }), ve([e, t, n], o ? [o] : [], function(W) {
        W = W[0];
        var Y, V;
        o ? (Y = W.registeredClass, V = Y.instancePrototype) : V = Je.prototype;
        var J = qt(A, function() {
          if (Object.getPrototypeOf(this) !== g)
            throw new $e("Use 'new' to construct " + C);
          if (P.constructor_body === void 0)
            throw new $e(C + " has no accessible constructor");
          var tt = P.constructor_body[arguments.length];
          if (tt === void 0)
            throw new $e(`Tried to invoke ctor of ${C} with invalid number of parameters (${arguments.length}) - expected (${Object.keys(P.constructor_body).toString()}) parameters instead!`);
          return tt.apply(this, arguments);
        }), g = Object.create(V, { constructor: { value: J } });
        J.prototype = g;
        var P = new An(C, J, g, O, Y, u, d, y);
        P.baseClass && (P.baseClass.__derivedClasses === void 0 && (P.baseClass.__derivedClasses = []), P.baseClass.__derivedClasses.push(P));
        var G = new Qe(C, P, !0, !1, !1), N = new Qe(C + "*", P, !1, !1, !1), ye = new Qe(C + " const*", P, !1, !0, !1);
        return Bt[e] = { pointerType: N, constPointerType: ye }, Qt(A, J), [G, N, ye];
      });
    }, bt = (e, t) => {
      for (var n = [], o = 0; o < e; o++)
        n.push(I[t + o * 4 >> 2]);
      return n;
    };
    function Ct(e, t, n, o, s, u) {
      var l = t.length;
      l < 2 && R("argTypes array size mismatch! Must at least get return value and 'this' types!");
      for (var d = t[1] !== null && n !== null, h = !1, y = 1; y < t.length; ++y)
        if (t[y] !== null && t[y].destructorFunction === void 0) {
          h = !0;
          break;
        }
      var C = t[0].name !== "void", T = l - 2, O = new Array(T), A = [], W = [];
      return function() {
        arguments.length !== T && R(`function ${e} called with ${arguments.length} arguments, expected ${T}`), W.length = 0;
        var Y;
        A.length = d ? 2 : 1, A[0] = s, d && (Y = t[1].toWireType(W, this), A[1] = Y);
        for (var V = 0; V < T; ++V)
          O[V] = t[V + 2].toWireType(W, arguments[V]), A.push(O[V]);
        var J = o.apply(null, A);
        function g(P) {
          if (h)
            Ut(W);
          else
            for (var G = d ? 1 : 2; G < t.length; G++) {
              var N = G === 1 ? Y : O[G - 2];
              t[G].destructorFunction !== null && t[G].destructorFunction(N);
            }
          if (C)
            return t[0].fromWireType(P);
        }
        return g(J);
      };
    }
    var Vn = (e, t, n, o, s, u) => {
      var l = bt(t, n);
      s = te(o, s), ve([], [e], function(d) {
        d = d[0];
        var h = `constructor ${d.name}`;
        if (d.registeredClass.constructor_body === void 0 && (d.registeredClass.constructor_body = []), d.registeredClass.constructor_body[t - 1] !== void 0)
          throw new $e(`Cannot register multiple constructors with identical number of parameters (${t - 1}) for class '${d.name}'! Overload resolution is currently only performed using the parameter count, not actual type info!`);
        return d.registeredClass.constructor_body[t - 1] = () => {
          Ke(`Cannot construct ${d.name} due to unbound types`, l);
        }, ve([], l, (y) => (y.splice(1, 0, null), d.registeredClass.constructor_body[t - 1] = Ct(h, y, null, s, u), [])), [];
      });
    }, zn = (e, t, n, o, s, u, l, d, h) => {
      var y = bt(n, o);
      t = Q(t), u = te(s, u), ve([], [e], function(C) {
        C = C[0];
        var T = `${C.name}.${t}`;
        t.startsWith("@@") && (t = Symbol[t.substring(2)]), d && C.registeredClass.pureVirtualFunctions.push(t);
        function O() {
          Ke(`Cannot call ${T} due to unbound types`, y);
        }
        var A = C.registeredClass.instancePrototype, W = A[t];
        return W === void 0 || W.overloadTable === void 0 && W.className !== C.name && W.argCount === n - 2 ? (O.argCount = n - 2, O.className = C.name, A[t] = O) : (Nt(A, t, T), A[t].overloadTable[n - 2] = O), ve([], y, function(Y) {
          var V = Ct(T, Y, C, u, l);
          return A[t].overloadTable === void 0 ? (V.argCount = n - 2, A[t] = V) : A[t].overloadTable[n - 2] = V, [];
        }), [];
      });
    };
    function Bn() {
      Object.assign(er.prototype, { get(e) {
        return this.allocated[e];
      }, has(e) {
        return this.allocated[e] !== void 0;
      }, allocate(e) {
        var t = this.freelist.pop() || this.allocated.length;
        return this.allocated[t] = e, t;
      }, free(e) {
        this.allocated[e] = void 0, this.freelist.push(e);
      } });
    }
    function er() {
      this.allocated = [void 0], this.freelist = [];
    }
    var ee = new er(), tr = (e) => {
      e >= ee.reserved && --ee.get(e).refcount === 0 && ee.free(e);
    }, Gn = () => {
      for (var e = 0, t = ee.reserved; t < ee.allocated.length; ++t)
        ee.allocated[t] !== void 0 && ++e;
      return e;
    }, qn = () => {
      ee.allocated.push({ value: void 0 }, { value: null }, { value: !0 }, { value: !1 }), ee.reserved = ee.allocated.length, a.count_emval_handles = Gn;
    }, de = { toValue: (e) => (e || R("Cannot use deleted val. handle = " + e), ee.get(e).value), toHandle: (e) => {
      switch (e) {
        case void 0:
          return 1;
        case null:
          return 2;
        case !0:
          return 3;
        case !1:
          return 4;
        default:
          return ee.allocate({ refcount: 1, value: e });
      }
    } }, Nn = (e, t) => {
      t = Q(t), se(e, { name: t, fromWireType: (n) => {
        var o = de.toValue(n);
        return tr(n), o;
      }, toWireType: (n, o) => de.toHandle(o), argPackAdvance: ce, readValueFromPointer: mt, destructorFunction: null });
    }, _t = (e) => {
      if (e === null)
        return "null";
      var t = typeof e;
      return t === "object" || t === "array" || t === "function" ? e.toString() : "" + e;
    }, Yn = (e, t) => {
      switch (t) {
        case 4:
          return function(n) {
            return this.fromWireType(we[n >> 2]);
          };
        case 8:
          return function(n) {
            return this.fromWireType(be[n >> 3]);
          };
        default:
          throw new TypeError(`invalid float width (${t}): ${e}`);
      }
    }, Jn = (e, t, n) => {
      t = Q(t), se(e, { name: t, fromWireType: (o) => o, toWireType: (o, s) => s, argPackAdvance: ce, readValueFromPointer: Yn(t, n), destructorFunction: null });
    }, Qn = (e, t, n, o, s, u, l) => {
      var d = bt(t, n);
      e = Q(e), s = te(o, s), Yt(e, function() {
        Ke(`Cannot call ${e} due to unbound types`, d);
      }, t - 1), ve([], d, function(h) {
        var y = [h[0], null].concat(h.slice(1));
        return Qt(e, Ct(e, y, null, s, u), t - 1), [];
      });
    }, Zn = (e, t, n) => {
      switch (t) {
        case 1:
          return n ? (o) => U[o >> 0] : (o) => E[o >> 0];
        case 2:
          return n ? (o) => F[o >> 1] : (o) => q[o >> 1];
        case 4:
          return n ? (o) => B[o >> 2] : (o) => I[o >> 2];
        default:
          throw new TypeError(`invalid integer width (${t}): ${e}`);
      }
    }, Kn = (e, t, n, o, s) => {
      t = Q(t);
      var u = (C) => C;
      if (o === 0) {
        var l = 32 - 8 * n;
        u = (C) => C << l >>> l;
      }
      var d = t.includes("unsigned"), h = (C, T) => {
      }, y;
      d ? y = function(C, T) {
        return h(T, this.name), T >>> 0;
      } : y = function(C, T) {
        return h(T, this.name), T;
      }, se(e, { name: t, fromWireType: u, toWireType: y, argPackAdvance: ce, readValueFromPointer: Zn(t, n, o !== 0), destructorFunction: null });
    }, Xn = (e, t, n) => {
      var o = [Int8Array, Uint8Array, Int16Array, Uint16Array, Int32Array, Uint32Array, Float32Array, Float64Array], s = o[t];
      function u(l) {
        var d = I[l >> 2], h = I[l + 4 >> 2];
        return new s(U.buffer, h, d);
      }
      n = Q(n), se(e, { name: n, fromWireType: u, argPackAdvance: ce, readValueFromPointer: u }, { ignoreDuplicateRegistrations: !0 });
    }, rr = (e, t, n, o) => {
      if (!(o > 0))
        return 0;
      for (var s = n, u = n + o - 1, l = 0; l < e.length; ++l) {
        var d = e.charCodeAt(l);
        if (d >= 55296 && d <= 57343) {
          var h = e.charCodeAt(++l);
          d = 65536 + ((d & 1023) << 10) | h & 1023;
        }
        if (d <= 127) {
          if (n >= u)
            break;
          t[n++] = d;
        } else if (d <= 2047) {
          if (n + 1 >= u)
            break;
          t[n++] = 192 | d >> 6, t[n++] = 128 | d & 63;
        } else if (d <= 65535) {
          if (n + 2 >= u)
            break;
          t[n++] = 224 | d >> 12, t[n++] = 128 | d >> 6 & 63, t[n++] = 128 | d & 63;
        } else {
          if (n + 3 >= u)
            break;
          t[n++] = 240 | d >> 18, t[n++] = 128 | d >> 12 & 63, t[n++] = 128 | d >> 6 & 63, t[n++] = 128 | d & 63;
        }
      }
      return t[n] = 0, n - s;
    }, ea = (e, t, n) => rr(e, E, t, n), nr = (e) => {
      for (var t = 0, n = 0; n < e.length; ++n) {
        var o = e.charCodeAt(n);
        o <= 127 ? t++ : o <= 2047 ? t += 2 : o >= 55296 && o <= 57343 ? (t += 4, ++n) : t += 3;
      }
      return t;
    }, ar = typeof TextDecoder < "u" ? new TextDecoder("utf8") : void 0, ta = (e, t, n) => {
      for (var o = t + n, s = t; e[s] && !(s >= o); )
        ++s;
      if (s - t > 16 && e.buffer && ar)
        return ar.decode(e.subarray(t, s));
      for (var u = ""; t < s; ) {
        var l = e[t++];
        if (!(l & 128)) {
          u += String.fromCharCode(l);
          continue;
        }
        var d = e[t++] & 63;
        if ((l & 224) == 192) {
          u += String.fromCharCode((l & 31) << 6 | d);
          continue;
        }
        var h = e[t++] & 63;
        if ((l & 240) == 224 ? l = (l & 15) << 12 | d << 6 | h : l = (l & 7) << 18 | d << 12 | h << 6 | e[t++] & 63, l < 65536)
          u += String.fromCharCode(l);
        else {
          var y = l - 65536;
          u += String.fromCharCode(55296 | y >> 10, 56320 | y & 1023);
        }
      }
      return u;
    }, $t = (e, t) => e ? ta(E, e, t) : "", ra = (e, t) => {
      t = Q(t);
      var n = t === "std::string";
      se(e, { name: t, fromWireType(o) {
        var s = I[o >> 2], u = o + 4, l;
        if (n)
          for (var d = u, h = 0; h <= s; ++h) {
            var y = u + h;
            if (h == s || E[y] == 0) {
              var C = y - d, T = $t(d, C);
              l === void 0 ? l = T : (l += String.fromCharCode(0), l += T), d = y + 1;
            }
          }
        else {
          for (var O = new Array(s), h = 0; h < s; ++h)
            O[h] = String.fromCharCode(E[u + h]);
          l = O.join("");
        }
        return ue(o), l;
      }, toWireType(o, s) {
        s instanceof ArrayBuffer && (s = new Uint8Array(s));
        var u, l = typeof s == "string";
        l || s instanceof Uint8Array || s instanceof Uint8ClampedArray || s instanceof Int8Array || R("Cannot pass non-string to std::string"), n && l ? u = nr(s) : u = s.length;
        var d = Pt(4 + u + 1), h = d + 4;
        if (I[d >> 2] = u, n && l)
          ea(s, h, u + 1);
        else if (l)
          for (var y = 0; y < u; ++y) {
            var C = s.charCodeAt(y);
            C > 255 && (ue(h), R("String has UTF-16 code units that do not fit in 8 bits")), E[h + y] = C;
          }
        else
          for (var y = 0; y < u; ++y)
            E[h + y] = s[y];
        return o !== null && o.push(ue, d), d;
      }, argPackAdvance: ce, readValueFromPointer: Jt, destructorFunction(o) {
        ue(o);
      } });
    }, or = typeof TextDecoder < "u" ? new TextDecoder("utf-16le") : void 0, na = (e, t) => {
      for (var n = e, o = n >> 1, s = o + t / 2; !(o >= s) && q[o]; )
        ++o;
      if (n = o << 1, n - e > 32 && or)
        return or.decode(E.subarray(e, n));
      for (var u = "", l = 0; !(l >= t / 2); ++l) {
        var d = F[e + l * 2 >> 1];
        if (d == 0)
          break;
        u += String.fromCharCode(d);
      }
      return u;
    }, aa = (e, t, n) => {
      if (n === void 0 && (n = 2147483647), n < 2)
        return 0;
      n -= 2;
      for (var o = t, s = n < e.length * 2 ? n / 2 : e.length, u = 0; u < s; ++u) {
        var l = e.charCodeAt(u);
        F[t >> 1] = l, t += 2;
      }
      return F[t >> 1] = 0, t - o;
    }, oa = (e) => e.length * 2, ia = (e, t) => {
      for (var n = 0, o = ""; !(n >= t / 4); ) {
        var s = B[e + n * 4 >> 2];
        if (s == 0)
          break;
        if (++n, s >= 65536) {
          var u = s - 65536;
          o += String.fromCharCode(55296 | u >> 10, 56320 | u & 1023);
        } else
          o += String.fromCharCode(s);
      }
      return o;
    }, sa = (e, t, n) => {
      if (n === void 0 && (n = 2147483647), n < 4)
        return 0;
      for (var o = t, s = o + n - 4, u = 0; u < e.length; ++u) {
        var l = e.charCodeAt(u);
        if (l >= 55296 && l <= 57343) {
          var d = e.charCodeAt(++u);
          l = 65536 + ((l & 1023) << 10) | d & 1023;
        }
        if (B[t >> 2] = l, t += 4, t + 4 > s)
          break;
      }
      return B[t >> 2] = 0, t - o;
    }, ca = (e) => {
      for (var t = 0, n = 0; n < e.length; ++n) {
        var o = e.charCodeAt(n);
        o >= 55296 && o <= 57343 && ++n, t += 4;
      }
      return t;
    }, ua = (e, t, n) => {
      n = Q(n);
      var o, s, u, l, d;
      t === 2 ? (o = na, s = aa, l = oa, u = () => q, d = 1) : t === 4 && (o = ia, s = sa, l = ca, u = () => I, d = 2), se(e, { name: n, fromWireType: (h) => {
        for (var y = I[h >> 2], C = u(), T, O = h + 4, A = 0; A <= y; ++A) {
          var W = h + 4 + A * t;
          if (A == y || C[W >> d] == 0) {
            var Y = W - O, V = o(O, Y);
            T === void 0 ? T = V : (T += String.fromCharCode(0), T += V), O = W + t;
          }
        }
        return ue(h), T;
      }, toWireType: (h, y) => {
        typeof y != "string" && R(`Cannot pass non-string to C++ string type ${n}`);
        var C = l(y), T = Pt(4 + C + t);
        return I[T >> 2] = C >> d, s(y, T + 4, C + t), h !== null && h.push(ue, T), T;
      }, argPackAdvance: ce, readValueFromPointer: mt, destructorFunction(h) {
        ue(h);
      } });
    }, la = (e, t, n, o, s, u) => {
      Ge[e] = { name: Q(t), rawConstructor: te(n, o), rawDestructor: te(s, u), fields: [] };
    }, da = (e, t, n, o, s, u, l, d, h, y) => {
      Ge[e].fields.push({ fieldName: Q(t), getterReturnType: n, getter: te(o, s), getterContext: u, setterArgumentType: l, setter: te(d, h), setterContext: y });
    }, fa = (e, t) => {
      t = Q(t), se(e, { isVoid: !0, name: t, argPackAdvance: 0, fromWireType: () => {
      }, toWireType: (n, o) => {
      } });
    }, ha = {}, pa = (e) => {
      var t = ha[e];
      return t === void 0 ? Q(e) : t;
    }, ir = () => {
      if (typeof globalThis == "object")
        return globalThis;
      function e(t) {
        t.$$$embind_global$$$ = t;
        var n = typeof $$$embind_global$$$ == "object" && t.$$$embind_global$$$ == t;
        return n || delete t.$$$embind_global$$$, n;
      }
      if (typeof $$$embind_global$$$ == "object" || (typeof global == "object" && e(global) ? $$$embind_global$$$ = global : typeof self == "object" && e(self) && ($$$embind_global$$$ = self), typeof $$$embind_global$$$ == "object"))
        return $$$embind_global$$$;
      throw Error("unable to get global object.");
    }, ma = (e) => e === 0 ? de.toHandle(ir()) : (e = pa(e), de.toHandle(ir()[e])), va = (e) => {
      e > 4 && (ee.get(e).refcount += 1);
    }, sr = (e, t) => {
      var n = me[e];
      return n === void 0 && R(t + " has unknown type " + Xt(e)), n;
    }, ya = (e) => {
      var t = new Array(e + 1);
      return function(n, o, s) {
        t[0] = n;
        for (var u = 0; u < e; ++u) {
          var l = sr(I[o + u * 4 >> 2], "parameter " + u);
          t[u + 1] = l.readValueFromPointer(s), s += l.argPackAdvance;
        }
        var d = new (n.bind.apply(n, t))();
        return de.toHandle(d);
      };
    }, cr = {}, ga = (e, t, n, o) => {
      e = de.toValue(e);
      var s = cr[t];
      return s || (s = ya(t), cr[t] = s), s(e, n, o);
    }, wa = (e, t) => {
      e = sr(e, "_emval_take_value");
      var n = e.readValueFromPointer(t);
      return de.toHandle(n);
    }, ba = () => {
      Ce("");
    }, Ca = (e, t, n) => E.copyWithin(e, t, t + n), _a = () => 2147483648, $a = (e) => {
      var t = j.buffer, n = (e - t.byteLength + 65535) / 65536;
      try {
        return j.grow(n), Te(), 1;
      } catch (o) {
      }
    }, Sa = (e) => {
      var t = E.length;
      e >>>= 0;
      var n = _a();
      if (e > n)
        return !1;
      for (var o = (h, y) => h + (y - h % y) % y, s = 1; s <= 4; s *= 2) {
        var u = t * (1 + 0.2 / s);
        u = Math.min(u, e + 100663296);
        var l = Math.min(n, o(Math.max(e, u), 65536)), d = $a(l);
        if (d)
          return !0;
      }
      return !1;
    }, St = {}, Pa = () => m || "./this.program", ke = () => {
      if (!ke.strings) {
        var e = (typeof navigator == "object" && navigator.languages && navigator.languages[0] || "C").replace("-", "_") + ".UTF-8", t = { USER: "web_user", LOGNAME: "web_user", PATH: "/", PWD: "/", HOME: "/home/web_user", LANG: e, _: Pa() };
        for (var n in St)
          St[n] === void 0 ? delete t[n] : t[n] = St[n];
        var o = [];
        for (var n in t)
          o.push(`${n}=${t[n]}`);
        ke.strings = o;
      }
      return ke.strings;
    }, Ta = (e, t) => {
      for (var n = 0; n < e.length; ++n)
        U[t++ >> 0] = e.charCodeAt(n);
      U[t >> 0] = 0;
    }, Ea = (e, t) => {
      var n = 0;
      return ke().forEach((o, s) => {
        var u = t + n;
        I[e + s * 4 >> 2] = u, Ta(o, u), n += o.length + 1;
      }), 0;
    }, Oa = (e, t) => {
      var n = ke();
      I[e >> 2] = n.length;
      var o = 0;
      return n.forEach((s) => o += s.length + 1), I[t >> 2] = o, 0;
    }, Da = (e) => e, Xe = (e) => e % 4 === 0 && (e % 100 !== 0 || e % 400 === 0), Ma = (e, t) => {
      for (var n = 0, o = 0; o <= t; n += e[o++])
        ;
      return n;
    }, ur = [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31], lr = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31], xa = (e, t) => {
      for (var n = new Date(e.getTime()); t > 0; ) {
        var o = Xe(n.getFullYear()), s = n.getMonth(), u = (o ? ur : lr)[s];
        if (t > u - n.getDate())
          t -= u - n.getDate() + 1, n.setDate(1), s < 11 ? n.setMonth(s + 1) : (n.setMonth(0), n.setFullYear(n.getFullYear() + 1));
        else
          return n.setDate(n.getDate() + t), n;
      }
      return n;
    };
    function Aa(e, t, n) {
      var o = n > 0 ? n : nr(e) + 1, s = new Array(o), u = rr(e, s, 0, s.length);
      return t && (s.length = u), s;
    }
    var Ra = (e, t) => {
      U.set(e, t);
    }, ka = (e, t, n, o) => {
      var s = I[o + 40 >> 2], u = { tm_sec: B[o >> 2], tm_min: B[o + 4 >> 2], tm_hour: B[o + 8 >> 2], tm_mday: B[o + 12 >> 2], tm_mon: B[o + 16 >> 2], tm_year: B[o + 20 >> 2], tm_wday: B[o + 24 >> 2], tm_yday: B[o + 28 >> 2], tm_isdst: B[o + 32 >> 2], tm_gmtoff: B[o + 36 >> 2], tm_zone: s ? $t(s) : "" }, l = $t(n), d = { "%c": "%a %b %d %H:%M:%S %Y", "%D": "%m/%d/%y", "%F": "%Y-%m-%d", "%h": "%b", "%r": "%I:%M:%S %p", "%R": "%H:%M", "%T": "%H:%M:%S", "%x": "%m/%d/%y", "%X": "%H:%M:%S", "%Ec": "%c", "%EC": "%C", "%Ex": "%m/%d/%y", "%EX": "%H:%M:%S", "%Ey": "%y", "%EY": "%Y", "%Od": "%d", "%Oe": "%e", "%OH": "%H", "%OI": "%I", "%Om": "%m", "%OM": "%M", "%OS": "%S", "%Ou": "%u", "%OU": "%U", "%OV": "%V", "%Ow": "%w", "%OW": "%W", "%Oy": "%y" };
      for (var h in d)
        l = l.replace(new RegExp(h, "g"), d[h]);
      var y = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"], C = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];
      function T(g, P, G) {
        for (var N = typeof g == "number" ? g.toString() : g || ""; N.length < P; )
          N = G[0] + N;
        return N;
      }
      function O(g, P) {
        return T(g, P, "0");
      }
      function A(g, P) {
        function G(ye) {
          return ye < 0 ? -1 : ye > 0 ? 1 : 0;
        }
        var N;
        return (N = G(g.getFullYear() - P.getFullYear())) === 0 && (N = G(g.getMonth() - P.getMonth())) === 0 && (N = G(g.getDate() - P.getDate())), N;
      }
      function W(g) {
        switch (g.getDay()) {
          case 0:
            return new Date(g.getFullYear() - 1, 11, 29);
          case 1:
            return g;
          case 2:
            return new Date(g.getFullYear(), 0, 3);
          case 3:
            return new Date(g.getFullYear(), 0, 2);
          case 4:
            return new Date(g.getFullYear(), 0, 1);
          case 5:
            return new Date(g.getFullYear() - 1, 11, 31);
          case 6:
            return new Date(g.getFullYear() - 1, 11, 30);
        }
      }
      function Y(g) {
        var P = xa(new Date(g.tm_year + 1900, 0, 1), g.tm_yday), G = new Date(P.getFullYear(), 0, 4), N = new Date(P.getFullYear() + 1, 0, 4), ye = W(G), tt = W(N);
        return A(ye, P) <= 0 ? A(tt, P) <= 0 ? P.getFullYear() + 1 : P.getFullYear() : P.getFullYear() - 1;
      }
      var V = { "%a": (g) => y[g.tm_wday].substring(0, 3), "%A": (g) => y[g.tm_wday], "%b": (g) => C[g.tm_mon].substring(0, 3), "%B": (g) => C[g.tm_mon], "%C": (g) => {
        var P = g.tm_year + 1900;
        return O(P / 100 | 0, 2);
      }, "%d": (g) => O(g.tm_mday, 2), "%e": (g) => T(g.tm_mday, 2, " "), "%g": (g) => Y(g).toString().substring(2), "%G": (g) => Y(g), "%H": (g) => O(g.tm_hour, 2), "%I": (g) => {
        var P = g.tm_hour;
        return P == 0 ? P = 12 : P > 12 && (P -= 12), O(P, 2);
      }, "%j": (g) => O(g.tm_mday + Ma(Xe(g.tm_year + 1900) ? ur : lr, g.tm_mon - 1), 3), "%m": (g) => O(g.tm_mon + 1, 2), "%M": (g) => O(g.tm_min, 2), "%n": () => `
`, "%p": (g) => g.tm_hour >= 0 && g.tm_hour < 12 ? "AM" : "PM", "%S": (g) => O(g.tm_sec, 2), "%t": () => "	", "%u": (g) => g.tm_wday || 7, "%U": (g) => {
        var P = g.tm_yday + 7 - g.tm_wday;
        return O(Math.floor(P / 7), 2);
      }, "%V": (g) => {
        var P = Math.floor((g.tm_yday + 7 - (g.tm_wday + 6) % 7) / 7);
        if ((g.tm_wday + 371 - g.tm_yday - 2) % 7 <= 2 && P++, P) {
          if (P == 53) {
            var G = (g.tm_wday + 371 - g.tm_yday) % 7;
            G != 4 && (G != 3 || !Xe(g.tm_year)) && (P = 1);
          }
        } else {
          P = 52;
          var N = (g.tm_wday + 7 - g.tm_yday - 1) % 7;
          (N == 4 || N == 5 && Xe(g.tm_year % 400 - 1)) && P++;
        }
        return O(P, 2);
      }, "%w": (g) => g.tm_wday, "%W": (g) => {
        var P = g.tm_yday + 7 - (g.tm_wday + 6) % 7;
        return O(Math.floor(P / 7), 2);
      }, "%y": (g) => (g.tm_year + 1900).toString().substring(2), "%Y": (g) => g.tm_year + 1900, "%z": (g) => {
        var P = g.tm_gmtoff, G = P >= 0;
        return P = Math.abs(P) / 60, P = P / 60 * 100 + P % 60, (G ? "+" : "-") + ("0000" + P).slice(-4);
      }, "%Z": (g) => g.tm_zone, "%%": () => "%" };
      l = l.replace(/%%/g, "\0\0");
      for (var h in V)
        l.includes(h) && (l = l.replace(new RegExp(h, "g"), V[h](u)));
      l = l.replace(/\0\0/g, "%");
      var J = Aa(l, !1);
      return J.length > t ? 0 : (Ra(J, e), J.length - 1);
    }, Fa = (e, t, n, o, s) => ka(e, t, n, o);
    Ht = a.InternalError = class extends Error {
      constructor(e) {
        super(e), this.name = "InternalError";
      }
    }, yn(), $e = a.BindingError = class extends Error {
      constructor(e) {
        super(e), this.name = "BindingError";
      }
    }, Dn(), Pn(), In(), Kt = a.UnboundTypeError = Ln(Error, "UnboundTypeError"), Bn(), qn();
    var Ia = { q: an, u: on, a: cn, h: un, l: ln, I: dn, P: fn, n: hn, ba: pn, d: sn, oa: mn, Y: vn, fa: wn, na: Wn, ma: Vn, D: zn, ea: Nn, W: Jn, J: Qn, w: Kn, s: Xn, V: ra, L: ua, Q: la, pa: da, ga: fa, U: tr, la: ma, R: va, ia: ga, ka: wa, K: ba, da: Ca, ca: Sa, $: Ea, aa: Oa, H: to, T: lo, B: no, p: Ka, b: ja, C: eo, ha: oo, c: Va, j: Ba, i: La, x: ro, O: Xa, v: Qa, G: so, N: co, A: ao, F: fo, Z: po, X: mo, k: za, f: Wa, e: Ha, g: Ua, M: uo, m: Ja, o: Ga, S: qa, t: Ya, ja: Za, y: io, r: Na, E: ho, z: Da, _: Fa }, z = nn(), ue = a._free = (e) => (ue = a._free = z.sa)(e), Pt = a._malloc = (e) => (Pt = a._malloc = z.ta)(e), dr = (e) => (dr = z.va)(e);
    a.__embind_initialize_bindings = () => (a.__embind_initialize_bindings = z.wa)();
    var D = (e, t) => (D = z.xa)(e, t), Fe = (e) => (Fe = z.ya)(e), M = () => (M = z.za)(), x = (e) => (x = z.Aa)(e), fr = (e) => (fr = z.Ba)(e), hr = (e) => (hr = z.Ca)(e), pr = (e, t, n) => (pr = z.Da)(e, t, n), mr = (e) => (mr = z.Ea)(e);
    a.dynCall_viijii = (e, t, n, o, s, u, l) => (a.dynCall_viijii = z.Fa)(e, t, n, o, s, u, l);
    var vr = a.dynCall_jiii = (e, t, n, o) => (vr = a.dynCall_jiii = z.Ga)(e, t, n, o), yr = a.dynCall_jiiii = (e, t, n, o, s) => (yr = a.dynCall_jiiii = z.Ha)(e, t, n, o, s);
    a.dynCall_iiiiij = (e, t, n, o, s, u, l) => (a.dynCall_iiiiij = z.Ia)(e, t, n, o, s, u, l), a.dynCall_iiiiijj = (e, t, n, o, s, u, l, d, h) => (a.dynCall_iiiiijj = z.Ja)(e, t, n, o, s, u, l, d, h), a.dynCall_iiiiiijj = (e, t, n, o, s, u, l, d, h, y) => (a.dynCall_iiiiiijj = z.Ka)(e, t, n, o, s, u, l, d, h, y);
    function ja(e, t) {
      var n = M();
      try {
        return k(e)(t);
      } catch (o) {
        if (x(n), o !== o + 0)
          throw o;
        D(1, 0);
      }
    }
    function Ua(e, t, n, o) {
      var s = M();
      try {
        k(e)(t, n, o);
      } catch (u) {
        if (x(s), u !== u + 0)
          throw u;
        D(1, 0);
      }
    }
    function Ha(e, t, n) {
      var o = M();
      try {
        k(e)(t, n);
      } catch (s) {
        if (x(o), s !== s + 0)
          throw s;
        D(1, 0);
      }
    }
    function La(e, t, n, o, s) {
      var u = M();
      try {
        return k(e)(t, n, o, s);
      } catch (l) {
        if (x(u), l !== l + 0)
          throw l;
        D(1, 0);
      }
    }
    function Wa(e, t) {
      var n = M();
      try {
        k(e)(t);
      } catch (o) {
        if (x(n), o !== o + 0)
          throw o;
        D(1, 0);
      }
    }
    function Va(e, t, n) {
      var o = M();
      try {
        return k(e)(t, n);
      } catch (s) {
        if (x(o), s !== s + 0)
          throw s;
        D(1, 0);
      }
    }
    function za(e) {
      var t = M();
      try {
        k(e)();
      } catch (n) {
        if (x(t), n !== n + 0)
          throw n;
        D(1, 0);
      }
    }
    function Ba(e, t, n, o) {
      var s = M();
      try {
        return k(e)(t, n, o);
      } catch (u) {
        if (x(s), u !== u + 0)
          throw u;
        D(1, 0);
      }
    }
    function Ga(e, t, n, o, s, u) {
      var l = M();
      try {
        k(e)(t, n, o, s, u);
      } catch (d) {
        if (x(l), d !== d + 0)
          throw d;
        D(1, 0);
      }
    }
    function qa(e, t, n, o, s, u, l) {
      var d = M();
      try {
        k(e)(t, n, o, s, u, l);
      } catch (h) {
        if (x(d), h !== h + 0)
          throw h;
        D(1, 0);
      }
    }
    function Na(e, t, n, o, s, u, l, d, h, y, C) {
      var T = M();
      try {
        k(e)(t, n, o, s, u, l, d, h, y, C);
      } catch (O) {
        if (x(T), O !== O + 0)
          throw O;
        D(1, 0);
      }
    }
    function Ya(e, t, n, o, s, u, l, d) {
      var h = M();
      try {
        k(e)(t, n, o, s, u, l, d);
      } catch (y) {
        if (x(h), y !== y + 0)
          throw y;
        D(1, 0);
      }
    }
    function Ja(e, t, n, o, s) {
      var u = M();
      try {
        k(e)(t, n, o, s);
      } catch (l) {
        if (x(u), l !== l + 0)
          throw l;
        D(1, 0);
      }
    }
    function Qa(e, t, n, o, s, u, l) {
      var d = M();
      try {
        return k(e)(t, n, o, s, u, l);
      } catch (h) {
        if (x(d), h !== h + 0)
          throw h;
        D(1, 0);
      }
    }
    function Za(e, t, n, o, s, u, l, d, h) {
      var y = M();
      try {
        k(e)(t, n, o, s, u, l, d, h);
      } catch (C) {
        if (x(y), C !== C + 0)
          throw C;
        D(1, 0);
      }
    }
    function Ka(e) {
      var t = M();
      try {
        return k(e)();
      } catch (n) {
        if (x(t), n !== n + 0)
          throw n;
        D(1, 0);
      }
    }
    function Xa(e, t, n, o, s, u, l) {
      var d = M();
      try {
        return k(e)(t, n, o, s, u, l);
      } catch (h) {
        if (x(d), h !== h + 0)
          throw h;
        D(1, 0);
      }
    }
    function eo(e, t, n, o) {
      var s = M();
      try {
        return k(e)(t, n, o);
      } catch (u) {
        if (x(s), u !== u + 0)
          throw u;
        D(1, 0);
      }
    }
    function to(e, t, n, o) {
      var s = M();
      try {
        return k(e)(t, n, o);
      } catch (u) {
        if (x(s), u !== u + 0)
          throw u;
        D(1, 0);
      }
    }
    function ro(e, t, n, o, s, u) {
      var l = M();
      try {
        return k(e)(t, n, o, s, u);
      } catch (d) {
        if (x(l), d !== d + 0)
          throw d;
        D(1, 0);
      }
    }
    function no(e, t, n, o, s, u) {
      var l = M();
      try {
        return k(e)(t, n, o, s, u);
      } catch (d) {
        if (x(l), d !== d + 0)
          throw d;
        D(1, 0);
      }
    }
    function ao(e, t, n, o, s, u, l, d, h, y) {
      var C = M();
      try {
        return k(e)(t, n, o, s, u, l, d, h, y);
      } catch (T) {
        if (x(C), T !== T + 0)
          throw T;
        D(1, 0);
      }
    }
    function oo(e, t, n) {
      var o = M();
      try {
        return k(e)(t, n);
      } catch (s) {
        if (x(o), s !== s + 0)
          throw s;
        D(1, 0);
      }
    }
    function io(e, t, n, o, s, u, l, d, h, y) {
      var C = M();
      try {
        k(e)(t, n, o, s, u, l, d, h, y);
      } catch (T) {
        if (x(C), T !== T + 0)
          throw T;
        D(1, 0);
      }
    }
    function so(e, t, n, o, s, u, l, d) {
      var h = M();
      try {
        return k(e)(t, n, o, s, u, l, d);
      } catch (y) {
        if (x(h), y !== y + 0)
          throw y;
        D(1, 0);
      }
    }
    function co(e, t, n, o, s, u, l, d, h) {
      var y = M();
      try {
        return k(e)(t, n, o, s, u, l, d, h);
      } catch (C) {
        if (x(y), C !== C + 0)
          throw C;
        D(1, 0);
      }
    }
    function uo(e, t, n, o, s, u, l) {
      var d = M();
      try {
        k(e)(t, n, o, s, u, l);
      } catch (h) {
        if (x(d), h !== h + 0)
          throw h;
        D(1, 0);
      }
    }
    function lo(e, t, n, o) {
      var s = M();
      try {
        return k(e)(t, n, o);
      } catch (u) {
        if (x(s), u !== u + 0)
          throw u;
        D(1, 0);
      }
    }
    function fo(e, t, n, o, s, u, l, d, h, y, C, T) {
      var O = M();
      try {
        return k(e)(t, n, o, s, u, l, d, h, y, C, T);
      } catch (A) {
        if (x(O), A !== A + 0)
          throw A;
        D(1, 0);
      }
    }
    function ho(e, t, n, o, s, u, l, d, h, y, C, T, O, A, W, Y) {
      var V = M();
      try {
        k(e)(t, n, o, s, u, l, d, h, y, C, T, O, A, W, Y);
      } catch (J) {
        if (x(V), J !== J + 0)
          throw J;
        D(1, 0);
      }
    }
    function po(e, t, n, o) {
      var s = M();
      try {
        return vr(e, t, n, o);
      } catch (u) {
        if (x(s), u !== u + 0)
          throw u;
        D(1, 0);
      }
    }
    function mo(e, t, n, o, s) {
      var u = M();
      try {
        return yr(e, t, n, o, s);
      } catch (l) {
        if (x(u), l !== l + 0)
          throw l;
        D(1, 0);
      }
    }
    var et;
    X = function e() {
      et || gr(), et || (X = e);
    };
    function gr() {
      if (ae > 0 || (st(), ae > 0))
        return;
      function e() {
        et || (et = !0, a.calledRun = !0, !L && (ct(), c(a), a.onRuntimeInitialized && a.onRuntimeInitialized(), ut()));
      }
      a.setStatus ? (a.setStatus("Running..."), setTimeout(function() {
        setTimeout(function() {
          a.setStatus("");
        }, 1), e();
      }, 1)) : e();
    }
    if (a.preInit)
      for (typeof a.preInit == "function" && (a.preInit = [a.preInit]); a.preInit.length > 0; )
        a.preInit.pop()();
    return gr(), i.ready;
  };
})();
function Ho(r) {
  return kt(Ft, r);
}
async function Lo(r, {
  tryHarder: i = Z.tryHarder,
  formats: a = Z.formats,
  maxSymbols: c = Z.maxSymbols
} = Z) {
  return jo(
    r,
    {
      tryHarder: i,
      formats: a,
      maxSymbols: c
    },
    Ft
  );
}
async function Wo(r, {
  tryHarder: i = Z.tryHarder,
  formats: a = Z.formats,
  maxSymbols: c = Z.maxSymbols
} = Z) {
  return Uo(
    r,
    {
      tryHarder: i,
      formats: a,
      maxSymbols: c
    },
    Ft
  );
}
const Dt = /* @__PURE__ */ new Map([
  ["aztec", "Aztec"],
  ["code_128", "Code128"],
  ["code_39", "Code39"],
  ["code_93", "Code93"],
  ["codabar", "Codabar"],
  ["data_matrix", "DataMatrix"],
  ["ean_13", "EAN-13"],
  ["ean_8", "EAN-8"],
  ["itf", "ITF"],
  ["pdf417", "PDF417"],
  ["qr_code", "QRCode"],
  ["upc_a", "UPC-A"],
  ["upc_e", "UPC-E"]
]);
function Vo(r) {
  for (const [i, a] of Dt)
    if (r === a)
      return i;
  return "unknown";
}
var je;
class it extends EventTarget {
  constructor(i = {}) {
    var a;
    super(), _o(this, je, void 0);
    try {
      const c = (a = i == null ? void 0 : i.formats) == null ? void 0 : a.filter(
        (f) => f !== "unknown"
      );
      if ((c == null ? void 0 : c.length) === 0)
        throw new TypeError("Hint option provided, but is empty.");
      c == null || c.forEach((f) => {
        if (!br.includes(f))
          throw new TypeError(
            `Failed to read the 'formats' property from 'BarcodeDetectorOptions': The provided value '${f}' is not a valid enum value of type BarcodeFormat.`
          );
      }), $o(this, je, c != null ? c : []), Ho().then((f) => {
        this.dispatchEvent(
          new CustomEvent("load", {
            detail: f
          })
        );
      }).catch((f) => {
        this.dispatchEvent(new CustomEvent("error", { detail: f }));
      });
    } catch (c) {
      throw Cr(
        c,
        "Failed to construct 'BarcodeDetector'"
      );
    }
  }
  static async getSupportedFormats() {
    return br.filter((i) => i !== "unknown");
  }
  async detect(i) {
    try {
      const a = await Do(i);
      if (a === null)
        return [];
      let c;
      try {
        Ur(a) ? c = await Lo(a, {
          tryHarder: !0,
          formats: wr(this, je).map(
            (f) => Dt.get(f)
          )
        }) : c = await Wo(a, {
          tryHarder: !0,
          formats: wr(this, je).map(
            (f) => Dt.get(f)
          )
        });
      } catch (f) {
        throw console.error(f), new DOMException(
          "Barcode detection service unavailable.",
          "NotSupportedError"
        );
      }
      return c.map((f) => {
        const {
          topLeft: { x: p, y: m },
          topRight: { x: w, y: b },
          bottomLeft: { x: v, y: _ },
          bottomRight: { x: S, y: $ }
        } = f.position, H = Math.min(p, w, v, S), j = Math.min(m, b, _, $), L = Math.max(p, w, v, S), U = Math.max(m, b, _, $);
        return {
          boundingBox: new DOMRectReadOnly(
            H,
            j,
            L - H,
            U - j
          ),
          rawValue: new TextDecoder().decode(f.bytes),
          format: Vo(f.format),
          cornerPoints: [
            {
              x: p,
              y: m
            },
            {
              x: w,
              y: b
            },
            {
              x: S,
              y: $
            },
            {
              x: v,
              y: _
            }
          ]
        };
      });
    } catch (a) {
      throw Cr(
        a,
        "Failed to execute 'detect' on 'BarcodeDetector'"
      );
    }
  }
}
je = /* @__PURE__ */ new WeakMap();
const It = (r, i, a = "error") => {
  let c, f;
  const p = new Promise(
    (m, w) => {
      c = m, f = w, r.addEventListener(i, c), r.addEventListener(a, f);
    }
  );
  return p.finally(() => {
    r.removeEventListener(i, c), r.removeEventListener(a, f);
  }), p;
}, Pr = (r) => new Promise((i) => setTimeout(i, r));
class zo extends Error {
  constructor() {
    super("can't process cross-origin image"), this.name = "DropImageFetchError";
  }
}
class Vr extends Error {
  constructor() {
    super("this browser has no Stream API support"), this.name = "StreamApiNotSupportedError";
  }
}
class Bo extends Error {
  constructor() {
    super(
      "camera access is only permitted in secure context. Use HTTPS or localhost rather than HTTP."
    ), this.name = "InsecureContextError";
  }
}
class Go extends Error {
  constructor() {
    super("Loading camera stream timed out after 3 seconds. If you are on iOS in PWA mode, this is a known issue (see https://github.com/gruhn/vue-qrcode-reader/issues/298)"), this.name = "StreamLoadTimeoutError";
  }
}
let Mt;
const qo = (r) => {
  Mt = new it({ formats: r });
}, No = async (r, {
  detectHandler: i,
  locateHandler: a,
  minDelay: c,
  formats: f
}) => {
  Mt = new it({ formats: f });
  const p = (m) => async (w) => {
    if (r.readyState > 1) {
      const { lastScanned: b, contentBefore: v, lastScanHadContent: _ } = m;
      if (w - b < c)
        window.requestAnimationFrame(p(m));
      else {
        const S = await Mt.detect(r), $ = S.some((L) => !v.includes(L.rawValue));
        $ && i(S);
        const H = S.length > 0;
        H && a(S), !H && _ && a(S);
        const j = {
          lastScanned: w,
          lastScanHadContent: H,
          // It can happen that a QR code is constantly in view of the camera but
          // maybe a scanned frame is a bit blurry and we detect nothing but in the
          // next frame we detect the code again. We also want to avoid emitting
          // a `detect` event in such a case. So we don't reset `contentBefore`,
          // if we detect nothing, only if we detect something new.
          contentBefore: $ ? S.map((L) => L.rawValue) : v
        };
        window.requestAnimationFrame(p(j));
      }
    }
  };
  p({
    lastScanned: performance.now(),
    contentBefore: [],
    lastScanHadContent: !1
  })(performance.now());
}, Yo = async (r) => {
  if (r.startsWith("http") && r.includes(location.host) === !1)
    throw new zo();
  const i = document.createElement("img");
  return i.src = r, await It(i, "load"), i;
}, zr = async (r, i = ["qr_code"]) => await new it({
  formats: i
}).detect(r), Jo = async (r, i = ["qr_code"]) => {
  const a = new it({
    formats: i
  }), c = await Yo(r);
  return await a.detect(c);
};
var Br = {}, K = {};
Object.defineProperty(K, "__esModule", {
  value: !0
});
K.compactObject = Nr;
K.deprecated = ai;
var Qo = K.detectBrowser = oi;
K.disableLog = ti;
K.disableWarnings = ri;
K.extractVersion = at;
K.filterStats = ii;
K.log = ni;
K.walkStats = ot;
K.wrapPeerConnectionEvent = ei;
function Zo(r, i, a) {
  return i = Ko(i), i in r ? Object.defineProperty(r, i, { value: a, enumerable: !0, configurable: !0, writable: !0 }) : r[i] = a, r;
}
function Ko(r) {
  var i = Xo(r, "string");
  return he(i) === "symbol" ? i : String(i);
}
function Xo(r, i) {
  if (he(r) !== "object" || r === null)
    return r;
  var a = r[Symbol.toPrimitive];
  if (a !== void 0) {
    var c = a.call(r, i || "default");
    if (he(c) !== "object")
      return c;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (i === "string" ? String : Number)(r);
}
function he(r) {
  "@babel/helpers - typeof";
  return he = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(i) {
    return typeof i;
  } : function(i) {
    return i && typeof Symbol == "function" && i.constructor === Symbol && i !== Symbol.prototype ? "symbol" : typeof i;
  }, he(r);
}
var Gr = !0, qr = !0;
function at(r, i, a) {
  var c = r.match(i);
  return c && c.length >= a && parseInt(c[a], 10);
}
function ei(r, i, a) {
  if (r.RTCPeerConnection) {
    var c = r.RTCPeerConnection.prototype, f = c.addEventListener;
    c.addEventListener = function(m, w) {
      if (m !== i)
        return f.apply(this, arguments);
      var b = function(_) {
        var S = a(_);
        S && (w.handleEvent ? w.handleEvent(S) : w(S));
      };
      return this._eventMap = this._eventMap || {}, this._eventMap[i] || (this._eventMap[i] = /* @__PURE__ */ new Map()), this._eventMap[i].set(w, b), f.apply(this, [m, b]);
    };
    var p = c.removeEventListener;
    c.removeEventListener = function(m, w) {
      if (m !== i || !this._eventMap || !this._eventMap[i])
        return p.apply(this, arguments);
      if (!this._eventMap[i].has(w))
        return p.apply(this, arguments);
      var b = this._eventMap[i].get(w);
      return this._eventMap[i].delete(w), this._eventMap[i].size === 0 && delete this._eventMap[i], Object.keys(this._eventMap).length === 0 && delete this._eventMap, p.apply(this, [m, b]);
    }, Object.defineProperty(c, "on" + i, {
      get: function() {
        return this["_on" + i];
      },
      set: function(w) {
        this["_on" + i] && (this.removeEventListener(i, this["_on" + i]), delete this["_on" + i]), w && this.addEventListener(i, this["_on" + i] = w);
      },
      enumerable: !0,
      configurable: !0
    });
  }
}
function ti(r) {
  return typeof r != "boolean" ? new Error("Argument type: " + he(r) + ". Please use a boolean.") : (Gr = r, r ? "adapter.js logging disabled" : "adapter.js logging enabled");
}
function ri(r) {
  return typeof r != "boolean" ? new Error("Argument type: " + he(r) + ". Please use a boolean.") : (qr = !r, "adapter.js deprecation warnings " + (r ? "disabled" : "enabled"));
}
function ni() {
  if ((typeof window > "u" ? "undefined" : he(window)) === "object") {
    if (Gr)
      return;
    typeof console < "u" && typeof console.log == "function" && console.log.apply(console, arguments);
  }
}
function ai(r, i) {
  qr && console.warn(r + " is deprecated, please use " + i + " instead.");
}
function oi(r) {
  var i = {
    browser: null,
    version: null
  };
  if (typeof r > "u" || !r.navigator || !r.navigator.userAgent)
    return i.browser = "Not a browser.", i;
  var a = r.navigator;
  if (a.mozGetUserMedia)
    i.browser = "firefox", i.version = at(a.userAgent, /Firefox\/(\d+)\./, 1);
  else if (a.webkitGetUserMedia || r.isSecureContext === !1 && r.webkitRTCPeerConnection)
    i.browser = "chrome", i.version = at(a.userAgent, /Chrom(e|ium)\/(\d+)\./, 2);
  else if (r.RTCPeerConnection && a.userAgent.match(/AppleWebKit\/(\d+)\./))
    i.browser = "safari", i.version = at(a.userAgent, /AppleWebKit\/(\d+)\./, 1), i.supportsUnifiedPlan = r.RTCRtpTransceiver && "currentDirection" in r.RTCRtpTransceiver.prototype;
  else
    return i.browser = "Not a supported browser.", i;
  return i;
}
function Tr(r) {
  return Object.prototype.toString.call(r) === "[object Object]";
}
function Nr(r) {
  return Tr(r) ? Object.keys(r).reduce(function(i, a) {
    var c = Tr(r[a]), f = c ? Nr(r[a]) : r[a], p = c && !Object.keys(f).length;
    return f === void 0 || p ? i : Object.assign(i, Zo({}, a, f));
  }, {}) : r;
}
function ot(r, i, a) {
  !i || a.has(i.id) || (a.set(i.id, i), Object.keys(i).forEach(function(c) {
    c.endsWith("Id") ? ot(r, r.get(i[c]), a) : c.endsWith("Ids") && i[c].forEach(function(f) {
      ot(r, r.get(f), a);
    });
  }));
}
function ii(r, i, a) {
  var c = a ? "outbound-rtp" : "inbound-rtp", f = /* @__PURE__ */ new Map();
  if (i === null)
    return f;
  var p = [];
  return r.forEach(function(m) {
    m.type === "track" && m.trackIdentifier === i.id && p.push(m);
  }), p.forEach(function(m) {
    r.forEach(function(w) {
      w.type === c && w.trackId === m.id && ot(r, w, f);
    });
  }), f;
}
Object.defineProperty(Br, "__esModule", {
  value: !0
});
var si = Br.shimGetUserMedia = li, ci = ui(K);
function Yr(r) {
  if (typeof WeakMap != "function")
    return null;
  var i = /* @__PURE__ */ new WeakMap(), a = /* @__PURE__ */ new WeakMap();
  return (Yr = function(f) {
    return f ? a : i;
  })(r);
}
function ui(r, i) {
  if (!i && r && r.__esModule)
    return r;
  if (r === null || fe(r) !== "object" && typeof r != "function")
    return { default: r };
  var a = Yr(i);
  if (a && a.has(r))
    return a.get(r);
  var c = {}, f = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var p in r)
    if (p !== "default" && Object.prototype.hasOwnProperty.call(r, p)) {
      var m = f ? Object.getOwnPropertyDescriptor(r, p) : null;
      m && (m.get || m.set) ? Object.defineProperty(c, p, m) : c[p] = r[p];
    }
  return c.default = r, a && a.set(r, c), c;
}
function fe(r) {
  "@babel/helpers - typeof";
  return fe = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(i) {
    return typeof i;
  } : function(i) {
    return i && typeof Symbol == "function" && i.constructor === Symbol && i !== Symbol.prototype ? "symbol" : typeof i;
  }, fe(r);
}
var Er = ci.log;
function li(r, i) {
  var a = r && r.navigator;
  if (a.mediaDevices) {
    var c = function(v) {
      if (fe(v) !== "object" || v.mandatory || v.optional)
        return v;
      var _ = {};
      return Object.keys(v).forEach(function(S) {
        if (!(S === "require" || S === "advanced" || S === "mediaSource")) {
          var $ = fe(v[S]) === "object" ? v[S] : {
            ideal: v[S]
          };
          $.exact !== void 0 && typeof $.exact == "number" && ($.min = $.max = $.exact);
          var H = function(U, E) {
            return U ? U + E.charAt(0).toUpperCase() + E.slice(1) : E === "deviceId" ? "sourceId" : E;
          };
          if ($.ideal !== void 0) {
            _.optional = _.optional || [];
            var j = {};
            typeof $.ideal == "number" ? (j[H("min", S)] = $.ideal, _.optional.push(j), j = {}, j[H("max", S)] = $.ideal, _.optional.push(j)) : (j[H("", S)] = $.ideal, _.optional.push(j));
          }
          $.exact !== void 0 && typeof $.exact != "number" ? (_.mandatory = _.mandatory || {}, _.mandatory[H("", S)] = $.exact) : ["min", "max"].forEach(function(L) {
            $[L] !== void 0 && (_.mandatory = _.mandatory || {}, _.mandatory[H(L, S)] = $[L]);
          });
        }
      }), v.advanced && (_.optional = (_.optional || []).concat(v.advanced)), _;
    }, f = function(v, _) {
      if (i.version >= 61)
        return _(v);
      if (v = JSON.parse(JSON.stringify(v)), v && fe(v.audio) === "object") {
        var S = function(U, E, F) {
          E in U && !(F in U) && (U[F] = U[E], delete U[E]);
        };
        v = JSON.parse(JSON.stringify(v)), S(v.audio, "autoGainControl", "googAutoGainControl"), S(v.audio, "noiseSuppression", "googNoiseSuppression"), v.audio = c(v.audio);
      }
      if (v && fe(v.video) === "object") {
        var $ = v.video.facingMode;
        $ = $ && (fe($) === "object" ? $ : {
          ideal: $
        });
        var H = i.version < 66;
        if ($ && ($.exact === "user" || $.exact === "environment" || $.ideal === "user" || $.ideal === "environment") && !(a.mediaDevices.getSupportedConstraints && a.mediaDevices.getSupportedConstraints().facingMode && !H)) {
          delete v.video.facingMode;
          var j;
          if ($.exact === "environment" || $.ideal === "environment" ? j = ["back", "rear"] : ($.exact === "user" || $.ideal === "user") && (j = ["front"]), j)
            return a.mediaDevices.enumerateDevices().then(function(L) {
              L = L.filter(function(E) {
                return E.kind === "videoinput";
              });
              var U = L.find(function(E) {
                return j.some(function(F) {
                  return E.label.toLowerCase().includes(F);
                });
              });
              return !U && L.length && j.includes("back") && (U = L[L.length - 1]), U && (v.video.deviceId = $.exact ? {
                exact: U.deviceId
              } : {
                ideal: U.deviceId
              }), v.video = c(v.video), Er("chrome: " + JSON.stringify(v)), _(v);
            });
        }
        v.video = c(v.video);
      }
      return Er("chrome: " + JSON.stringify(v)), _(v);
    }, p = function(v) {
      return i.version >= 64 ? v : {
        name: {
          PermissionDeniedError: "NotAllowedError",
          PermissionDismissedError: "NotAllowedError",
          InvalidStateError: "NotAllowedError",
          DevicesNotFoundError: "NotFoundError",
          ConstraintNotSatisfiedError: "OverconstrainedError",
          TrackStartError: "NotReadableError",
          MediaDeviceFailedDueToShutdown: "NotAllowedError",
          MediaDeviceKillSwitchOn: "NotAllowedError",
          TabCaptureError: "AbortError",
          ScreenCaptureError: "AbortError",
          DeviceCaptureError: "AbortError"
        }[v.name] || v.name,
        message: v.message,
        constraint: v.constraint || v.constraintName,
        toString: function() {
          return this.name + (this.message && ": ") + this.message;
        }
      };
    }, m = function(v, _, S) {
      f(v, function($) {
        a.webkitGetUserMedia($, _, function(H) {
          S && S(p(H));
        });
      });
    };
    if (a.getUserMedia = m.bind(a), a.mediaDevices.getUserMedia) {
      var w = a.mediaDevices.getUserMedia.bind(a.mediaDevices);
      a.mediaDevices.getUserMedia = function(b) {
        return f(b, function(v) {
          return w(v).then(function(_) {
            if (v.audio && !_.getAudioTracks().length || v.video && !_.getVideoTracks().length)
              throw _.getTracks().forEach(function(S) {
                S.stop();
              }), new DOMException("", "NotFoundError");
            return _;
          }, function(_) {
            return Promise.reject(p(_));
          });
        });
      };
    }
  }
}
var Jr = {};
Object.defineProperty(Jr, "__esModule", {
  value: !0
});
var di = Jr.shimGetUserMedia = pi, fi = hi(K);
function Qr(r) {
  if (typeof WeakMap != "function")
    return null;
  var i = /* @__PURE__ */ new WeakMap(), a = /* @__PURE__ */ new WeakMap();
  return (Qr = function(f) {
    return f ? a : i;
  })(r);
}
function hi(r, i) {
  if (!i && r && r.__esModule)
    return r;
  if (r === null || Se(r) !== "object" && typeof r != "function")
    return { default: r };
  var a = Qr(i);
  if (a && a.has(r))
    return a.get(r);
  var c = {}, f = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var p in r)
    if (p !== "default" && Object.prototype.hasOwnProperty.call(r, p)) {
      var m = f ? Object.getOwnPropertyDescriptor(r, p) : null;
      m && (m.get || m.set) ? Object.defineProperty(c, p, m) : c[p] = r[p];
    }
  return c.default = r, a && a.set(r, c), c;
}
function Se(r) {
  "@babel/helpers - typeof";
  return Se = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(i) {
    return typeof i;
  } : function(i) {
    return i && typeof Symbol == "function" && i.constructor === Symbol && i !== Symbol.prototype ? "symbol" : typeof i;
  }, Se(r);
}
function pi(r, i) {
  var a = r && r.navigator, c = r && r.MediaStreamTrack;
  if (a.getUserMedia = function(b, v, _) {
    fi.deprecated("navigator.getUserMedia", "navigator.mediaDevices.getUserMedia"), a.mediaDevices.getUserMedia(b).then(v, _);
  }, !(i.version > 55 && "autoGainControl" in a.mediaDevices.getSupportedConstraints())) {
    var f = function(v, _, S) {
      _ in v && !(S in v) && (v[S] = v[_], delete v[_]);
    }, p = a.mediaDevices.getUserMedia.bind(a.mediaDevices);
    if (a.mediaDevices.getUserMedia = function(b) {
      return Se(b) === "object" && Se(b.audio) === "object" && (b = JSON.parse(JSON.stringify(b)), f(b.audio, "autoGainControl", "mozAutoGainControl"), f(b.audio, "noiseSuppression", "mozNoiseSuppression")), p(b);
    }, c && c.prototype.getSettings) {
      var m = c.prototype.getSettings;
      c.prototype.getSettings = function() {
        var b = m.apply(this, arguments);
        return f(b, "mozAutoGainControl", "autoGainControl"), f(b, "mozNoiseSuppression", "noiseSuppression"), b;
      };
    }
    if (c && c.prototype.applyConstraints) {
      var w = c.prototype.applyConstraints;
      c.prototype.applyConstraints = function(b) {
        return this.kind === "audio" && Se(b) === "object" && (b = JSON.parse(JSON.stringify(b)), f(b, "autoGainControl", "mozAutoGainControl"), f(b, "noiseSuppression", "mozNoiseSuppression")), w.apply(this, [b]);
      };
    }
  }
}
var ne = {};
Object.defineProperty(ne, "__esModule", {
  value: !0
});
ne.shimAudioContext = Si;
ne.shimCallbacksAPI = wi;
ne.shimConstraints = Xr;
ne.shimCreateOfferLegacy = $i;
var mi = ne.shimGetUserMedia = bi;
ne.shimLocalStreamsAPI = yi;
ne.shimRTCIceServerUrls = Ci;
ne.shimRemoteStreamsAPI = gi;
ne.shimTrackEventTransceiver = _i;
var Zr = vi(K);
function Kr(r) {
  if (typeof WeakMap != "function")
    return null;
  var i = /* @__PURE__ */ new WeakMap(), a = /* @__PURE__ */ new WeakMap();
  return (Kr = function(f) {
    return f ? a : i;
  })(r);
}
function vi(r, i) {
  if (!i && r && r.__esModule)
    return r;
  if (r === null || pe(r) !== "object" && typeof r != "function")
    return { default: r };
  var a = Kr(i);
  if (a && a.has(r))
    return a.get(r);
  var c = {}, f = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var p in r)
    if (p !== "default" && Object.prototype.hasOwnProperty.call(r, p)) {
      var m = f ? Object.getOwnPropertyDescriptor(r, p) : null;
      m && (m.get || m.set) ? Object.defineProperty(c, p, m) : c[p] = r[p];
    }
  return c.default = r, a && a.set(r, c), c;
}
function pe(r) {
  "@babel/helpers - typeof";
  return pe = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(i) {
    return typeof i;
  } : function(i) {
    return i && typeof Symbol == "function" && i.constructor === Symbol && i !== Symbol.prototype ? "symbol" : typeof i;
  }, pe(r);
}
function yi(r) {
  if (!(pe(r) !== "object" || !r.RTCPeerConnection)) {
    if ("getLocalStreams" in r.RTCPeerConnection.prototype || (r.RTCPeerConnection.prototype.getLocalStreams = function() {
      return this._localStreams || (this._localStreams = []), this._localStreams;
    }), !("addStream" in r.RTCPeerConnection.prototype)) {
      var i = r.RTCPeerConnection.prototype.addTrack;
      r.RTCPeerConnection.prototype.addStream = function(c) {
        var f = this;
        this._localStreams || (this._localStreams = []), this._localStreams.includes(c) || this._localStreams.push(c), c.getAudioTracks().forEach(function(p) {
          return i.call(f, p, c);
        }), c.getVideoTracks().forEach(function(p) {
          return i.call(f, p, c);
        });
      }, r.RTCPeerConnection.prototype.addTrack = function(c) {
        for (var f = this, p = arguments.length, m = new Array(p > 1 ? p - 1 : 0), w = 1; w < p; w++)
          m[w - 1] = arguments[w];
        return m && m.forEach(function(b) {
          f._localStreams ? f._localStreams.includes(b) || f._localStreams.push(b) : f._localStreams = [b];
        }), i.apply(this, arguments);
      };
    }
    "removeStream" in r.RTCPeerConnection.prototype || (r.RTCPeerConnection.prototype.removeStream = function(c) {
      var f = this;
      this._localStreams || (this._localStreams = []);
      var p = this._localStreams.indexOf(c);
      if (p !== -1) {
        this._localStreams.splice(p, 1);
        var m = c.getTracks();
        this.getSenders().forEach(function(w) {
          m.includes(w.track) && f.removeTrack(w);
        });
      }
    });
  }
}
function gi(r) {
  if (!(pe(r) !== "object" || !r.RTCPeerConnection) && ("getRemoteStreams" in r.RTCPeerConnection.prototype || (r.RTCPeerConnection.prototype.getRemoteStreams = function() {
    return this._remoteStreams ? this._remoteStreams : [];
  }), !("onaddstream" in r.RTCPeerConnection.prototype))) {
    Object.defineProperty(r.RTCPeerConnection.prototype, "onaddstream", {
      get: function() {
        return this._onaddstream;
      },
      set: function(c) {
        var f = this;
        this._onaddstream && (this.removeEventListener("addstream", this._onaddstream), this.removeEventListener("track", this._onaddstreampoly)), this.addEventListener("addstream", this._onaddstream = c), this.addEventListener("track", this._onaddstreampoly = function(p) {
          p.streams.forEach(function(m) {
            if (f._remoteStreams || (f._remoteStreams = []), !f._remoteStreams.includes(m)) {
              f._remoteStreams.push(m);
              var w = new Event("addstream");
              w.stream = m, f.dispatchEvent(w);
            }
          });
        });
      }
    });
    var i = r.RTCPeerConnection.prototype.setRemoteDescription;
    r.RTCPeerConnection.prototype.setRemoteDescription = function() {
      var c = this;
      return this._onaddstreampoly || this.addEventListener("track", this._onaddstreampoly = function(f) {
        f.streams.forEach(function(p) {
          if (c._remoteStreams || (c._remoteStreams = []), !(c._remoteStreams.indexOf(p) >= 0)) {
            c._remoteStreams.push(p);
            var m = new Event("addstream");
            m.stream = p, c.dispatchEvent(m);
          }
        });
      }), i.apply(c, arguments);
    };
  }
}
function wi(r) {
  if (!(pe(r) !== "object" || !r.RTCPeerConnection)) {
    var i = r.RTCPeerConnection.prototype, a = i.createOffer, c = i.createAnswer, f = i.setLocalDescription, p = i.setRemoteDescription, m = i.addIceCandidate;
    i.createOffer = function(v, _) {
      var S = arguments.length >= 2 ? arguments[2] : arguments[0], $ = a.apply(this, [S]);
      return _ ? ($.then(v, _), Promise.resolve()) : $;
    }, i.createAnswer = function(v, _) {
      var S = arguments.length >= 2 ? arguments[2] : arguments[0], $ = c.apply(this, [S]);
      return _ ? ($.then(v, _), Promise.resolve()) : $;
    };
    var w = function(v, _, S) {
      var $ = f.apply(this, [v]);
      return S ? ($.then(_, S), Promise.resolve()) : $;
    };
    i.setLocalDescription = w, w = function(v, _, S) {
      var $ = p.apply(this, [v]);
      return S ? ($.then(_, S), Promise.resolve()) : $;
    }, i.setRemoteDescription = w, w = function(v, _, S) {
      var $ = m.apply(this, [v]);
      return S ? ($.then(_, S), Promise.resolve()) : $;
    }, i.addIceCandidate = w;
  }
}
function bi(r) {
  var i = r && r.navigator;
  if (i.mediaDevices && i.mediaDevices.getUserMedia) {
    var a = i.mediaDevices, c = a.getUserMedia.bind(a);
    i.mediaDevices.getUserMedia = function(f) {
      return c(Xr(f));
    };
  }
  !i.getUserMedia && i.mediaDevices && i.mediaDevices.getUserMedia && (i.getUserMedia = (function(p, m, w) {
    i.mediaDevices.getUserMedia(p).then(m, w);
  }).bind(i));
}
function Xr(r) {
  return r && r.video !== void 0 ? Object.assign({}, r, {
    video: Zr.compactObject(r.video)
  }) : r;
}
function Ci(r) {
  if (r.RTCPeerConnection) {
    var i = r.RTCPeerConnection;
    r.RTCPeerConnection = function(c, f) {
      if (c && c.iceServers) {
        for (var p = [], m = 0; m < c.iceServers.length; m++) {
          var w = c.iceServers[m];
          w.urls === void 0 && w.url ? (Zr.deprecated("RTCIceServer.url", "RTCIceServer.urls"), w = JSON.parse(JSON.stringify(w)), w.urls = w.url, delete w.url, p.push(w)) : p.push(c.iceServers[m]);
        }
        c.iceServers = p;
      }
      return new i(c, f);
    }, r.RTCPeerConnection.prototype = i.prototype, "generateCertificate" in i && Object.defineProperty(r.RTCPeerConnection, "generateCertificate", {
      get: function() {
        return i.generateCertificate;
      }
    });
  }
}
function _i(r) {
  pe(r) === "object" && r.RTCTrackEvent && "receiver" in r.RTCTrackEvent.prototype && !("transceiver" in r.RTCTrackEvent.prototype) && Object.defineProperty(r.RTCTrackEvent.prototype, "transceiver", {
    get: function() {
      return {
        receiver: this.receiver
      };
    }
  });
}
function $i(r) {
  var i = r.RTCPeerConnection.prototype.createOffer;
  r.RTCPeerConnection.prototype.createOffer = function(c) {
    if (c) {
      typeof c.offerToReceiveAudio < "u" && (c.offerToReceiveAudio = !!c.offerToReceiveAudio);
      var f = this.getTransceivers().find(function(m) {
        return m.receiver.track.kind === "audio";
      });
      c.offerToReceiveAudio === !1 && f ? f.direction === "sendrecv" ? f.setDirection ? f.setDirection("sendonly") : f.direction = "sendonly" : f.direction === "recvonly" && (f.setDirection ? f.setDirection("inactive") : f.direction = "inactive") : c.offerToReceiveAudio === !0 && !f && this.addTransceiver("audio", {
        direction: "recvonly"
      }), typeof c.offerToReceiveVideo < "u" && (c.offerToReceiveVideo = !!c.offerToReceiveVideo);
      var p = this.getTransceivers().find(function(m) {
        return m.receiver.track.kind === "video";
      });
      c.offerToReceiveVideo === !1 && p ? p.direction === "sendrecv" ? p.setDirection ? p.setDirection("sendonly") : p.direction = "sendonly" : p.direction === "recvonly" && (p.setDirection ? p.setDirection("inactive") : p.direction = "inactive") : c.offerToReceiveVideo === !0 && !p && this.addTransceiver("video", {
        direction: "recvonly"
      });
    }
    return i.apply(this, arguments);
  };
}
function Si(r) {
  pe(r) !== "object" || r.AudioContext || (r.AudioContext = r.webkitAudioContext);
}
const Pi = (r) => {
  let i = !1, a;
  return (...c) => (i || (a = r(c), i = !0), a);
};
function le(r, i) {
  if (r === !1)
    throw new Error(i != null ? i : "assertion failure");
}
const Ti = Pi(() => {
  const r = Qo(window);
  switch (r.browser) {
    case "chrome":
      si(window, r);
      break;
    case "firefox":
      di(window, r);
      break;
    case "safari":
      mi(window, r);
      break;
    default:
      throw new Vr();
  }
});
let Pe = Promise.resolve({ type: "stop", data: {} });
async function Or(r, i, a) {
  var w, b, v;
  if (window.isSecureContext !== !0)
    throw new Bo();
  if (((w = navigator == null ? void 0 : navigator.mediaDevices) == null ? void 0 : w.getUserMedia) === void 0)
    throw new Vr();
  Ti();
  const c = await navigator.mediaDevices.getUserMedia({
    audio: !1,
    video: i
  });
  r.srcObject !== void 0 ? r.srcObject = c : r.mozSrcObject !== void 0 ? r.mozSrcObject = c : window.URL.createObjectURL ? r.src = window.URL.createObjectURL(c) : window.webkitURL ? r.src = window.webkitURL.createObjectURL(c) : r.src = c.id, r.play(), await Promise.race([
    It(r, "loadeddata"),
    // On iOS devices in PWA mode, QrcodeStream works initially, but after
    // killing and restarting the PWA, all video elements fail to load camera
    // streams and never emit the `loadeddata` event. Looks like this is
    // related to a WebKit issue (see #298). No workarounds at the moment.
    // To at least detect this situation, we throw an error if the event
    // has not been emitted after a 3 second timeout.
    Pr(3e3).then(() => {
      throw new Go();
    })
  ]), await Pr(500);
  const [f] = c.getVideoTracks(), p = (v = (b = f == null ? void 0 : f.getCapabilities) == null ? void 0 : b.call(f)) != null ? v : {};
  let m = !1;
  return a && p.torch && (await f.applyConstraints({ advanced: [{ torch: !0 }] }), m = !0), {
    type: "start",
    data: {
      videoEl: r,
      stream: c,
      capabilities: p,
      constraints: i,
      isTorchOn: m
    }
  };
}
async function Ei(r, {
  constraints: i,
  torch: a,
  restart: c = !1
}) {
  Pe = Pe.then((p) => {
    if (p.type === "start") {
      const {
        data: {
          videoEl: m,
          stream: w,
          constraints: b,
          isTorchOn: v
        }
      } = p;
      return !c && r === m && i === b && a === v ? p : en(m, w, v).then(
        () => Or(r, i, a)
      );
    }
    return Or(r, i, a);
  });
  const f = await Pe;
  if (f.type === "stop")
    throw new Error("Something went wrong with the camera task queue (start task).");
  return f.data.capabilities;
}
async function en(r, i, a) {
  r.src = "", r.srcObject = null, r.load(), await It(r, "error");
  for (const c of i.getTracks())
    a != null || await c.applyConstraints({ advanced: [{ torch: !1 }] }), i.removeTrack(c), c.stop();
  return {
    type: "stop",
    data: {}
  };
}
async function Ot() {
  if (Pe = Pe.then((i) => {
    if (i.type === "stop")
      return i;
    const {
      data: { videoEl: a, stream: c, isTorchOn: f }
    } = i;
    return en(a, c, f);
  }), (await Pe).type === "start")
    throw new Error("Something went wrong with the camera task queue (stop task).");
}
const Oi = /* @__PURE__ */ xt({
  __name: "QrcodeStream",
  props: {
    constraints: {
      type: Object,
      default() {
        return { facingMode: "environment" };
      }
    },
    formats: {
      type: Array,
      default: () => ["qr_code"]
    },
    paused: {
      type: Boolean,
      default: !1
    },
    torch: {
      type: Boolean,
      default: !1
    },
    track: {
      type: Function
    }
  },
  emits: ["detect", "camera-on", "camera-off", "error"],
  setup(r, { emit: i }) {
    const a = r, c = Ie(), f = Ie(), p = Ie(), m = Ie(!1), w = Ie(!1);
    vo(() => {
      w.value = !0;
    }), yo(() => {
      Ot();
    });
    const b = Tt(() => ({
      torch: a.torch,
      constraints: a.constraints,
      shouldStream: w.value && !a.paused
    }));
    Et(b, async (E) => {
      const F = p.value;
      le(F !== void 0, "cameraSettings watcher should never be triggered when component is not mounted. Thus video element should always be defined.");
      const q = c.value;
      le(q !== void 0, "cameraSettings watcher should never be triggered when component is not mounted. Thus canvas should always be defined.");
      const B = q.getContext("2d");
      if (le(B !== null, "if cavnas is defined, canvas 2d context should also be non-null"), E.shouldStream)
        try {
          const I = await Ei(F, E);
          w.value ? (m.value = !0, i("camera-on", I)) : await Ot();
        } catch (I) {
          i("error", I);
        }
      else
        q.width = F.videoWidth, q.height = F.videoHeight, B.drawImage(F, 0, 0, F.videoWidth, F.videoHeight), Ot(), m.value = !1, i("camera-off");
    }, { deep: !0 });
    const { formats: v } = go(a);
    Et(v, (E) => {
      w.value && qo(E);
    });
    const _ = Tt(() => b.value.shouldStream && m.value);
    Et(_, (E) => {
      if (E) {
        le(c.value !== void 0, "shouldScan watcher should only be triggered when component is mounted. Thus pause frame canvas is defined"), S(c.value), le(f.value !== void 0, "shouldScan watcher should only be triggered when component is mounted. Thus tracking canvas is defined"), S(f.value);
        const F = () => a.track === void 0 ? 500 : 40;
        le(p.value !== void 0, "shouldScan watcher should only be triggered when component is mounted. Thus video element is defined"), No(p.value, {
          detectHandler: (q) => i("detect", q),
          formats: a.formats,
          locateHandler: $,
          minDelay: F()
        });
      }
    });
    const S = (E) => {
      const F = E.getContext("2d");
      le(F !== null, "canvas 2d context should always be non-null"), F.clearRect(0, 0, E.width, E.height);
    }, $ = (E) => {
      const F = f.value;
      le(F !== void 0, "onLocate handler should only be called when component is mounted. Thus tracking canvas is always defined.");
      const q = p.value;
      if (le(q !== void 0, "onLocate handler should only be called when component is mounted. Thus video element is always defined."), E.length === 0 || a.track === void 0)
        S(F);
      else {
        const B = q.offsetWidth, I = q.offsetHeight, we = q.videoWidth, be = q.videoHeight, Te = Math.max(B / we, I / be), Ee = we * Te, Oe = be * Te, Ue = Ee / we, st = Oe / be, ct = (B - Ee) / 2, ut = (I - Oe) / 2, De = ({ x: X, y: re }) => ({
          x: Math.floor(X * Ue),
          y: Math.floor(re * st)
        }), He = ({ x: X, y: re }) => ({
          x: Math.floor(X + ct),
          y: Math.floor(re + ut)
        }), lt = E.map((X) => {
          const { boundingBox: re, cornerPoints: dt } = X, { x: Ce, y: ft } = He(
            De({
              x: re.x,
              y: re.y
            })
          ), { x: Le, y: oe } = De({
            x: re.width,
            y: re.height
          });
          return {
            ...X,
            cornerPoints: dt.map((We) => He(De(We))),
            boundingBox: DOMRectReadOnly.fromRect({ x: Ce, y: ft, width: Le, height: oe })
          };
        });
        F.width = q.offsetWidth, F.height = q.offsetHeight;
        const ae = F.getContext("2d");
        a.track(lt, ae);
      }
    }, H = {
      width: "100%",
      height: "100%",
      position: "relative",
      // notice that we use z-index only once for the wrapper div.
      // If z-index is not defined, elements are stacked in the order they appear in the DOM.
      // The first element is at the very bottom and subsequent elements are added on top.
      "z-index": "0"
    }, j = {
      width: "100%",
      height: "100%",
      position: "absolute",
      top: "0",
      left: "0"
    }, L = {
      width: "100%",
      height: "100%",
      "object-fit": "cover"
    }, U = Tt(() => _.value ? L : {
      ...L,
      visibility: "hidden",
      position: "absolute"
    });
    return (E, F) => (At(), Rt("div", { style: H }, [
      rt("video", {
        ref_key: "videoRef",
        ref: p,
        style: wo(U.value),
        autoplay: "",
        muted: "",
        playsinline: ""
      }, null, 4),
      bo(rt("canvas", {
        id: "qrcode-stream-pause-frame",
        ref_key: "pauseFrameRef",
        ref: c,
        style: L
      }, null, 512), [
        [Co, !_.value]
      ]),
      rt("canvas", {
        id: "qrcode-stream-tracking-layer",
        ref_key: "trackingLayerRef",
        ref: f,
        style: j
      }, null, 512),
      rt("div", { style: j }, [
        Dr(E.$slots, "default")
      ])
    ]));
  }
}), Di = /* @__PURE__ */ xt({
  __name: "QrcodeCapture",
  props: {
    formats: {
      type: Array,
      default: () => ["qr_code"]
    }
  },
  emits: ["detect"],
  setup(r, { emit: i }) {
    const a = r, c = (f) => {
      if (!(!(f.target instanceof HTMLInputElement) || !f.target.files))
        for (const p of Array.from(f.target.files))
          zr(p, a.formats).then((m) => {
            i("detect", m);
          });
    };
    return (f, p) => (At(), Rt("input", {
      onChange: c,
      type: "file",
      name: "image",
      accept: "image/*",
      capture: "environment",
      multiple: ""
    }, null, 32));
  }
}), Mi = ["onDrop"], xi = /* @__PURE__ */ xt({
  __name: "QrcodeDropZone",
  props: {
    formats: {
      type: Array,
      default: () => ["qr_code"]
    }
  },
  emits: ["detect", "dragover", "error"],
  setup(r, { emit: i }) {
    const a = r, c = async (m) => {
      try {
        const w = await m;
        i("detect", w);
      } catch (w) {
        i("error", w);
      }
    }, f = (m) => {
      i("dragover", m);
    }, p = ({ dataTransfer: m }) => {
      if (!m)
        return;
      f(!1);
      const w = [...Array.from(m.files)], b = m.getData("text/uri-list");
      w.forEach((v) => {
        c(zr(v));
      }), b !== "" && c(Jo(b, a.formats));
    };
    return (m, w) => (At(), Rt("div", {
      onDrop: nt(p, ["prevent", "stop"]),
      onDragenter: w[0] || (w[0] = nt((b) => f(!0), ["prevent", "stop"])),
      onDragleave: w[1] || (w[1] = nt((b) => f(!1), ["prevent", "stop"])),
      onDragover: w[2] || (w[2] = nt(() => {
      }, ["prevent", "stop"]))
    }, [
      Dr(m.$slots, "default")
    ], 40, Mi));
  }
});
function Ai(r) {
  r.component("qrcode-stream", Oi), r.component("qrcode-capture", Di), r.component("qrcode-drop-zone", xi);
}
const Fi = { install: Ai };
export {
  Di as QrcodeCapture,
  xi as QrcodeDropZone,
  Oi as QrcodeStream,
  Fi as VueQrcodeReader,
  Ai as install,
  ki as setZXingModuleOverrides
};
